;========================================================================================
;  rompat13.s
;  Copyright (C) 2003-2020 Makoto Kamada
;
;  This file is part of the XEiJ (X68000 Emulator in Java).
;  You can use, modify and redistribute the XEiJ if the conditions are met.
;  Read the XEiJ License for more details.
;  https://stdkmd.net/xeij/
;========================================================================================

;----------------------------------------------------------------
;
;	ROM 1.3̃pb`
;
;----------------------------------------------------------------

	.include	iocscall.mac
	.include	def_M.equ
	.include	rompat.mac

;----------------------------------------------------------------

ROM_VERSION	equ	$15210111	;ROM̃o[W

;----------------------------------------------------------------
;MFP

IERB	equ	$00E88009
IMRB	equ	$00E88015
TCDCR	equ	$00E8801D
TCDR	equ	$00E88023
TDDR	equ	$00E88025

;----------------------------------------------------------------
;SPC

;SPC
SPC_IN_BASE	equ	$00E96020	;SPCx[XAhX
SPC_EX_BASE	equ	$00EA0000	;gSPCx[XAhX
SPC_BASE	equ	SPC_IN_BASE	;SPCx[XAhXB$00E96020=,$00EA0000=g
aSPC		reg	a6		;SPC_xxx(aSPC)SPC̃WX^QƂ

;荞
SET_SCSI_INT	equ	1		;SCSI荞݂ݒ肷邩B0=Ȃ,1=
SCSI_INT_NUMBER	equ	$6C		;SCSI荞݂̃xN^ԍ

;SRAM
SCSI_MAGIC	equ	$00ED006F	;SCSI}WbN($56=SRAMς)
SCSI_SETTING	equ	$00ED0070	;SCSIݒ(ubN|^Cv|o[Xg|\tg|g|###)
SASI_FLAG	equ	$00ED0071	;SASI@̃tO

;SPC̃WX^
SPC_BDID	equ	$01		;Bus Device IDBID
SPC_BDID_I7	equ	%10000000	;  ID 7
SPC_BDID_I6	equ	%01000000	;  ID 6
SPC_BDID_I5	equ	%00100000	;  ID 5
SPC_BDID_I4	equ	%00010000	;  ID 4
SPC_BDID_I3	equ	%00001000	;  ID 3
SPC_BDID_I2	equ	%00000100	;  ID 2
SPC_BDID_I1	equ	%00000010	;  ID 1
SPC_BDID_I0	equ	%00000001	;  ID 0
SPC_SCTL	equ	$03		;SPC Control
SPC_SCTL_RD	equ	%10000000	;  Reset & Disable
					;    1=n[hEFAZbg
SPC_SCTL_CR	equ	%01000000	;  Control Reset
					;    1=]HZbg
SPC_SCTL_DM	equ	%00100000	;  Diag Mode
					;    1=Ȑff[h
SPC_SCTL_AE	equ	%00010000	;  Arbitration Enable
					;    0=A[rg[VtF[YȂ(SASI)
					;    1=(SCSI)
SPC_SCTL_PE	equ	%00001000	;  Parity Enable
					;    1=̓f[^̃peB`FbN
					;    o̓f[^͏ɃpeBt
SPC_SCTL_SE	equ	%00000100	;  Select Enable
					;    0=ɃCjVG[^
					;    1=ZNVtF[Y^[QbgɂȂ
SPC_SCTL_RE	equ	%00000010	;  Reselect Enable
					;    1=ZNVtF[Yɉ
SPC_SCTL_IE	equ	%00000001	;  Interrupt Enable
					;    0=荞݋֎~B֎~ĂĂINTS͕ω
					;    1=荞݋
SPC_SCMD	equ	$05		;SPC Command
SPC_SCMD_CC	equ	%11100000	;  Command Code
SPC_SCMD_CC_BR	equ	%00000000	;  Bus ReleaseB^[QbĝƂoXt[tF[Yֈڍs
SPC_SCMD_CC_SL	equ	%00100000	;  SelectBZNV/ZNVJn
SPC_SCMD_CC_RA	equ	%01000000	;  Reset ATNBATNNA
SPC_SCMD_CC_SA	equ	%01100000	;  Set ATNBATNZbg
SPC_SCMD_CC_TR	equ	%10000000	;  TransferB]Jn
SPC_SCMD_CC_TP	equ	%10100000	;  Transfer PauseB]f
SPC_SCMD_CC_RR	equ	%11000000	;  Reset ACK/REQBCPU]̂ƂACK/REQNA
SPC_SCMD_CC_SR	equ	%11100000	;  Set ACK/REQBCPU]̂ƂACK/REQZbg
SPC_SCMD_RO	equ	%00010000	;  RST Out
					;    1=SCSIoXZbg
SPC_SCMD_IT	equ	%00001000	;  Intercept Transfer
					;    1=CPU]FIFOobt@̓eێ
SPC_SCMD_PT	equ	%00000100	;  Program Transfer
					;    0=]
					;      DREQgDREGŃf[^Ƃ肷
					;    1=vO]
					;      SCMDACK/REQ𑀍삵TEMPŃf[^Ƃ肷
					;    X680x0łPEDECDREQgDREGDTACKĂ
					;    vO]̂ƂDREG͏ɃoXG[ɂȂ
SPC_SCMD_TM	equ	%00000001	;  Termination Mode
					;  CjVG[^̂Ƃ
					;    0=JEg0ŏI
					;    1=JEg0ŏIȂ(Padding)
					;  ^[QbĝƂ
					;    0=peBG[ĂJEg0܂œ]
					;    1=peBG[ƒɏI
SPC_INTS	equ	$09		;Interrupt Sense
SPC_INTS_SL	equ	%10000000	;  Selected
					;    1=̃foCX̃ZNVtF[YőIă^[QbgɂȂ
SPC_INTS_RS	equ	%01000000	;  Reselected
					;    1=̃foCX̃ZNVtF[YőIăCjVG[^ɂȂ
SPC_INTS_DC_BIT	equ	5
SPC_INTS_DC	equ	%00100000	;  Disconnected
					;    1=oXt[tF[YɂȂBoXgƂ0ɖ߂
SPC_INTS_CC	equ	%00010000	;  Command Complete
					;    1=SelectTransferȂǂ̃R}hI
					;    ^[QbĝƂpeBG[Œ~
SPC_INTS_SR	equ	%00001000	;  Service Required
					;    1=PCTLWX^ƃoX̃tF[YvȂ񂾂ǂǂɂ
SPC_INTS_TO	equ	%00000100	;  Time Out
					;    1=ZNV/ZNVɉȂ
					;    ZNV^CAEĝƂSEL1̂܂܂Ȃ̂
					;    TEMP=$00ŕKv
SPC_INTS_HE	equ	%00000010	;  SPC Hard Error
					;    1=Ȃ񂩃G[oBSERRĂ
SPC_INTS_RC	equ	%00000001	;  Reset Condition
					;    1=SCSIoXZbgꂽ(RSTM1ɂȂ)
SPC_PSNS	equ	$0B		;(Read) Phase Sense
SPC_PSNS_REQ	equ	%10000000	;  REQ
SPC_PSNS_ACK	equ	%01000000	;  ACK
SPC_PSNS_ATN	equ	%00100000	;  ATN
SPC_PSNS_SEL	equ	%00010000	;  SELB1=ZNVtF[Y
SPC_PSNS_BSY	equ	%00001000	;  BSY
SPC_PSNS_MSG	equ	%00000100	;  MSG
SPC_PSNS_CD	equ	%00000010	;  C/D
SPC_PSNS_IO	equ	%00000001	;  I/O
SPC_SDGC	equ	$0B		;(Write) SPC Diag Control
SPC_SDGC_REQ	equ	%10000000	;  Diag REQ
SPC_SDGC_ACK	equ	%01000000	;  Diag ACK
SPC_SDGC_XFER	equ	%00100000	;  Xfer EnableBCPU]̂Ƃ1=f[^]荞݋
SPC_SDGC_BSY	equ	%00001000	;  Diag BSY
SPC_SDGC_MSG	equ	%00000100	;  Diag MSG
SPC_SDGC_CD	equ	%00000010	;  Diag C/D
SPC_SDGC_IO	equ	%00000001	;  Diag I/O
SPC_SSTS	equ	$0D		;SPC Status
SPC_SSTS_INIT	equ	%10000000	;  Connected INITB1=CjVG[^
SPC_SSTS_TARG	equ	%01000000	;  Connected TARGB1=^[Qbg
SPC_SSTS_BUSY	equ	%00100000	;  SPC BusyB1=R}hs
SPC_SSTS_TRIP	equ	%00010000	;  Transfer in ProgressB1=DMA]
SPC_SSTS_SRIN	equ	%00001000	;  SCSI Reset InBRSTM̏
SPC_SSTS_TC0	equ	%00000100	;  TC=0B1=]JE^0
SPC_SSTS_DF	equ	%00000010	;  DREG status FullB1=8oCgFIFOt
SPC_SSTS_DE	equ	%00000001	;  DREG status EmptyB1=8oCgFIFO
SPC_SERR	equ	$0F		;SPC Error Status
SPC_SERR_DI	equ	%10000000	;  Data Error SCSIB1=̓f[^ɃpeBG[
SPC_SERR_DO	equ	%01000000	;  Data Error SPCB1=o̓f[^ɃpeBG[
SPC_SERR_XO	equ	%00100000	;  Xfer OutB1=Xfer EnablêƂData Request
SPC_SERR_PE	equ	%00001000	;  TC Parity ErrorB1=]JE^ɃpeBG[
SPC_SERR_ST	equ	%00000010	;  Short Transfer PeriodB1=REQ/ACKSPCǏ]łȂ
SPC_PCTL	equ	$11		;Phase Control
SPC_PCTL_IE	equ	%10000000	;  Busfree INT Enable
					;    1=oXt[tF[YoDisconnected荞݂v
SPC_PCTL_TP	equ	%00000111	;  Transfer PhaseB]tF[Y
SPC_PCTL_MSG	equ	%00000100	;  MSG
SPC_PCTL_CD	equ	%00000010	;  C/D
SPC_PCTL_IO	equ	%00000001	;  I/OB0=Out,1=In
SPC_PCTL_SR	equ	%00000001	;  SelectR}h̃ZNV/ZNVI
SPC_PCTL_SR_R	equ	%00000001	;  SelectR}hŃZNVJn
SPC_PCTL_SR_S	equ	%00000000	;  SelectR}hŃZNVJn
SPC_MBC		equ	$13		;Modified Byte Counter
SPC_DREG	equ	$15		;Data Register
					;    X680x0łPEDECDREQgDREGDTACKĂ
					;    DREG status Full̂ƂDREGɃCgƃoXG[ɂȂ
					;    DREG status EmptŷƂDREG烊[hƃoXG[ɂȂ
					;    vO]̂ƂDREG͏ɃoXG[ɂȂ
SPC_TEMP	equ	$17		;Temporary Register
SPC_TCH		equ	$19		;Transfer Counter High
SPC_TCM		equ	$1B		;Transfer Counter Mid
SPC_TCL		equ	$1D		;Transfer Counter Low

;tF[Y
SPC_PHASE_MASK		equ	%00000111
SPC_DATAOUT_PHASE	equ	%00000000	;Data Out PhaseBf[^AEgtF[Y
SPC_DATAIN_PHASE	equ	%00000001	;Data In PhaseBf[^CtF[Y
SPC_CMDOUT_PHASE	equ	%00000010	;Command PhaseBR}htF[Y
SPC_STSIN_PHASE		equ	%00000011	;Status PhaseBXe[^XtF[Y
SPC_MSGOUT_PHASE	equ	%00000110	;Message Out PhaseBbZ[WAEgtF[Y
SPC_MSGIN_PHASE		equ	%00000111	;Message In PhaseBbZ[WCtF[Y

;----------------------------------------------------------------
;gXCb`

EXTENSION_SWITCH	equ	$00ED0095
CRT_LCD_SWITCH		equ	0		;0=CRT,1=LCD

;----------------------------------------------------------------
;}N
	.nlist

;bscc
;bsncc
;	cc܂ncctruêƂbsetAfalsêƂbclr
  .irp %cc,hi,ls,cc,hs,cs,lo,ne,nz,eq,ze,vc,vs,pl,mi,ge,lt,gt,le
bs%cc	.macro	src,dst
	.sizem	sz
	b%cc	@set
	bclr&&sz	src,dst
	bra	@end

@set:
	bset&&sz	src,dst
@end:
	.endm
bsn%cc	.macro	src,dst
	.sizem	sz
	bn%cc	@set
	bclr&&sz	src,dst
	bra	@end

@set:
	bset&&sz	src,dst
@end:
	.endm
  .endm

____SRAM_WRITABLE____	.macro
	move.b	#$31,$00E8E00D		;SRAM݋
	.endm

____SRAM_READONLY____	.macro
	clr.b	$00E8E00D		;SRAM݋֎~
	.endm

	.list



;----------------------------------------------------------------
;
;	pb`f[^̐擪
;
;----------------------------------------------------------------

	.cpu	68000



;----------------------------------------------------------------
;
;	IOCS _ROMVER
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF0030 203C13921127           move.l	#$13921127,d0
;		00FF0036
;----------------------------------------------------------------

	PATCH_DATA	iocsRomver,$00FF0030,$00FF0036,$203C1392

	move.l	#ROM_VERSION,d0

	PATCH_TEXT
;		           111111111122222222223333333333444444444455555555556666
;		 0123456789012345678901234567890123456789012345678901234567890123
	.dc.b	'This is an IPLROM modified by XEiJ. Distribution is prohibited.',0
	.even

	PATCH_END



;----------------------------------------------------------------
;
;	䃌WX^̏MPU/MMU/FPŨ`FbN
;
;	Tu[`AhXϊ𖳌ɂƃX^bNGAړĖ߂ĂȂȂ̂jsrł͂Ȃjmpg
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF005A 61000CE2               bsr.w	$00FF0D3E		;MPU,MMU,FPU/FPCP`FbN
;		00FF005E 2E00                   move.l	d0,d7
;		00FF0060 4A07                   tst.b	d7
;		00FF0062 6710                   beq.s	$00FF0074		;68000
;		00FF0064 7000                   moveq.l	#$00,d0
;		00FF0066 4E7B0801               movec.l	d0,vbr
;		00FF006A 0C070001               cmpi.b	#$01,d7
;		00FF006E 6704                   beq.s	$00FF0074		;68010
;		00FF0070 4E7B0002               movec.l	d0,cacr			;LbVOFF
;		00FF0074 91C8                   suba.l	a0,a0
;		00FF0076 43FA06F8               lea.l	$00FF0770(pc),a1	;`O
;		00FF007A 610006B2               bsr.w	$00FF072E		;OxN^e[u256ݒ
;		00FF007E
;----------------------------------------------------------------

	PATCH_DATA	mpuCheck,$00FF005A,$00FF007E,$61000CE2

	jmp	mpuCheck

	PATCH_TEXT

;----------------------------------------------------------------
;MPU`FbN
;	NɊ荞݋֎~AX^bNgp̏ԂŃWvĂ
;	ROMTRAP#10̓zbgX^[gƂMMŨAhXϊ̏ԂmF$00FF0038ɃWvĂ
;	060turbo.sysTRAP#10tbNĂ̂ŃzbgX^[gꍇAhXϊ͊ɖĂ͂A
;	Ô߃AhXϊLɂȂĂꍇl
;	ROM̃R[h͕ωȂ̂ŖȂA
;	xN^e[uƃX^bNGAƃ[NGA̓e̓AhXϊ𖳌ɂuԂɎ
;	zbgX^[gX^bNGA⃏[NGAgOɃAhXϊ𖳌ɂȂ΂ȂȂ
;<d5.l:0=R[hX^[g(d0d1!='HotStart'),-1=zbgX^[g(d0d1=='HotStart')
;<d6.l:G~[^荞݃xN^([$0030.w].l)BR[hX^[ĝƂ`O[`wĂȂΓdONAwĂ΃Zbg
;>d7.l:MPU/MMU/FPŨ`FbŇ
;	bit31:0=MMUȂ,1=MMU
;	bit15:0=FPU/FPCPȂ,1=FPU/FPCP
;	bit7-0:0=MC68000,1=MC68010,2=MC68020,3=MC68030,4=MC68040,6=MC68060
;>a0.l:$00000400
;?d0/a1
mpuCheck:
	lea.l	dummyTrap(pc),a1
	move.l	a1,$0010.w		;[$0010.w].l:OxN^$04 s
	move.l	a1,$002C.w		;[$002C.w].l:OxN^$0B C1111G~[^
	movea.l	sp,a1

;----------------------------------------------------------------
;MOVEC to VBR(-12346)ȂMC68000
;	MC68000ǂ̃eXgVBR̃NA𓯎ɍs
;	sߗOxN^$0010.wɂ̂MC68000̏ꍇMC68010ȏVBR0̏ꍇ
;	MC68010ȏVBR0łȂƂ$0010.wĂsߗO𑨂Ȃ̂ŁA
;	MC68010ȏ̂Ƃ͍ŏVBRNAKv
;	VBRNA閽߂MC68000ŕs߂Ȃ̂MC68000ǂ̃eXg˂
	.cpu	68010
	lea.l	mpuCheckDone(pc),a0
	moveq.l	#0,d7			;MC68000
	moveq.l	#0,d0
	movec.l	d0,vbr
	.cpu	68000

;----------------------------------------------------------------
;MOVEC to VBR(-12346)ăXP[t@N^(--2346)ȂMC68010
	.cpu	68020
	moveq.l	#1,d7			;MC68010
@@:	moveq.l	#1,d0			;$70,$01
	and.b	(@b-1,pc,d0.w*2),d0	;XP[t@N^Ȃ(([@b-1+1].b==$70)&1)==0,XP[t@N^(([@b-1+1*2].b=$01)&1)==1
	beq	mpuCheckDone
	.cpu	68000

;----------------------------------------------------------------
;CALLM(--2---)MC68020
	.cpu	68020
	lea.l	9f(pc),a0
	callm	#0,1f(pc)
	moveq.l	#2,d7			;MC68020
;		  3  2 1 0
;		  C CE F E
	move.l	#%1__0_0_0,d0
	movec.l	d0,cacr			;߃LbVNAA߃LbVOFF
	lea.l	@f(pc),a0
	fnop
	bset.l	#15,d7			;FPU
@@:
;MC68851̃`FbN͏ȗ
	bra	mpuCheckDone

;W[fXNv^
1:	.dc.l	%0<<13|0<<24|0<<16	;option=0,type=0,accesslevel=0
	.dc.l	2f			;W[Gg|C^
	.dc.l	0			;W[f[^̈|C^
	.dc.l	0
;W[Gg
2:	.dc.w	15<<12			;Rn=sp
	rtm	sp

9:	movea.l	a1,sp
	.cpu	68000

;----------------------------------------------------------------
;CALLM(--2---)ȂMOVEC from CAAR(--23--)MC68030
	.cpu	68030
	lea.l	9f(pc),a0
	movec.l	caar,d0
	moveq.l	#3,d7			;MC68030
;		   D   C  B   A  9  8 765   4  3   2  1  0
;		  WA DBE CD CED FD ED     IBE CI CEI FI EI
	move.l	#%_0___0__1___0__0__0_000___0__1___0__0__0,d0
	movec.l	d0,cacr			;f[^LbVNAAf[^LbVOFFA߃LbVNAA߃LbVOFF
;		  F ECDBA   9   8 7654 3210 FEDC BA98 7654 3210
;		  E       SRE FCL   PS   IS  TIA  TIB  TIC  TID
	move.l	#%0_00000___0___0_1101_1000_0011_0100_0100_0000,-(sp)
	pmove.l	(sp),tc			;AhXϊOFF
;		  FEDCBA98 76543210 F EDCB  A   9   8 7    654 3    210
;		      BASE     MASK E      CI R/W RWM   FCBASE   FCMASK
	move.l	#%00000000_00000000_0_0000__0___0___0_0____000_0____000,(sp)
	pmove.l	(sp),tt0		;ߕϊOFF
	pmove.l	(sp),tt1
	addq.l	#4,sp
	lea.l	@f(pc),a0
	fnop
	bset.l	#15,d7			;FPU
@@:	bsr	mmuCheck3		;MMU`FbN(MC68030)
	bra	mpuCheckDone

9:
	.cpu	68000

;----------------------------------------------------------------
;MOVEC from MMUSR(----4-)MC68040
	.cpu	68040
	lea.l	9f(pc),a0
	movec.l	mmusr,d0
	moveq.l	#4,d7			;MC68040
;		   F EDCBA9876543210  F EDCBA9876543210
;		  DE 000000000000000 IE 000000000000000
	move.l	#%_0_000000000000000__0_000000000000000,d0
	movec.l	d0,cacr			;f[^LbVOFFA߃LbVOFF
	cinva	bc			;f[^LbVNAA߃LbVNA
;		  F E DCBA9876543210
;		  E P 00000000000000
	move.l	#%0_0_00000000000000,d0
	movec.l	d0,tc			;AhXϊ
	pflusha				;AhXϊLbVNA
;		  FEDCBA98 76543210 F     ED CBA  9  8 7 65 43 2 10
;		      BASE     MASK E SFIELD     U1 U0   CM    W
	move.l	#%00000000_00000000_0_____00_000__0__0_0_00_00_0_00,d0
	movec.l	d0,itt0			;ߕϊOFF
	movec.l	d0,itt1
	movec.l	d0,dtt0
	movec.l	d0,dtt1
	lea.l	@f(pc),a0
	fnop
	bset.l	#15,d7			;FPU
@@:	bsr	mmuCheck46		;MMU`FbN(MC68040/MC68060)
	bra	mpuCheckDone

9:
	.cpu	68000

;----------------------------------------------------------------
;MOVEC from PCR(-----6)MC68060
	.cpu	68060
	lea.l	9f(pc),a0
	movec.l	pcr,d1
	moveq.l	#6,d7			;MC68060
;		    F   E   D   C   B A98   7    6    5 43210   F   E   D CBA9876543210
;		  EDC NAD ESB DPI FOC     EBC CABC CUBC       EIC NAI FIC
	move.l	#%__0___0___0___0___0_000___1____0____0_00000___0___0___0_0000000000000,d0
	movec.l	d0,cacr			;f[^LbVOFFAXgAobt@OFFALbVONA߃LbVOFF
;	ZbgŃLbV̓NAȂ
;	ZbgꂽLbVLɂOɃLbVNAȂ΂ȂȂ(MC68060UM 5.3)
	cinva	bc			;f[^LbVNAA߃LbVNA
;		  F E   D   C    B    A  98  76   5  43  21 0
;		  E P NAD NAI FOTC FITC DCO DUO DWO DCI DUI
	move.l	#%0_0___0___0____0____0__10__00___0__10__00_0,d0
	movec.l	d0,tc			;AhXϊOFFAf[^LbVOFFvTCX[hA߃LbVOFFvTCX[h
;	ZbgŃAhXϊLbV̓NAȂ
;	ZbgꂽAhXϊLɂOɃAhXϊLbVNAȂ΂ȂȂ(MC68060UM 4.6.1)
	pflusha				;AhXϊLbVNA
;		  FEDCBA98 76543210 F     ED CBA  9  8 7 65 43 2 10
;		      BASE     MASK E SFIELD     U1 U0   CM    W
	move.l	#%00000000_00000000_0_____00_000__0__0_0_00_00_0_00,d0
	movec.l	d0,itt0			;ߕϊOFF
	movec.l	d0,itt1
	movec.l	d0,dtt0
	movec.l	d0,dtt1
;		  FEDCBA9876543210 FEDCBA98      7 65432   1   0
;		  0000010000110000 REVISION EDEBUG       DFP ESS
	move.l	#%0000000000000000_00000000______0_00000___0___1,d0
	movec.l	d0,pcr			;FPU ON,X[p[XJON
	lea.l	@f(pc),a0
	fnop
	bset.l	#15,d7			;FPU
@@:	bsr	mmuCheck46		;MMU`FbN(MC68040/MC68060)
	bra	mpuCheckDone

9:
	.cpu	68000

;----------------------------------------------------------------
;s
	moveq.l	#0,d7

;----------------------------------------------------------------
;I
mpuCheckDone:

;OxN^e[u
;	$0010.w$002C.w͂ŏ㏑
	suba.l	a0,a0
	lea.l	$00FF0770.l,a1		;`O
	moveq.l	#1,d1
	ror.l	#8,d1
	moveq.l	#256/2-1,d0
@@:
  .rept 2
	move.l	a1,(a0)+
	adda.l	d1,a1
  .endm
	dbra.w	d0,@b
;<a0.l:$00000400
;ߗO[`ݒ肷
	cmp.b	#6,d7
	bne	@f
	lea.l	uii(pc),a1		;ߗO[`
	move.l	a1,$00F4.w		;[$00F4.w].l:OxN^$3D 
@@:
;XvAX荞݃[`ݒ肷
	lea.l	uii_rte(pc),a1		;ߗO[`rte
	move.l	a1,$0060.w		;[$0060.w].l:OxN^$18 XvAX荞
;NMI[`̐ݒɖ߂
;<a0.l:$00000400
	jmp	$00FF007E

;----------------------------------------------------------------
;_~[̗O
;	a1spɃRs[a0ɃWv
dummyTrap:
	movea.l	a1,sp
	jmp	(a0)

;----------------------------------------------------------------
;MMU`FbN(MC68030)
mmuCheck3:
	.cpu	68030
	lea.l	-128(sp),sp
	movea.l	sp,a0
;		L/U           LIMIT                DT
	move.l	#%0_111111111111111_00000000000000_10,(a0)+
	move.l	sp,d0
	lsr.l	#4,d0
	addq.l	#2,d0
	lsl.l	#4,d0
	move.l	d0,(a0)
;			     CI   M U WP DT
	lea.l	$00000000|%0__0_0_0_0__0_01.w,a0
	movea.l	d0,a1
	moveq.l	#8-1,d0
@@:	move.l	a0,(a1)+
	adda.l	#$00200000,a0
	dbra	d0,@b
;AhXϊLɂ
;			      CI   M U WP DT
	move.l	#$00F00000|%0__0_0_0_0__0_01,-4*8+4(a1)	;$00200000$00F00000ɕϊ
	pmove.q	(sp),crp
;		  E       SRE FCL   PS   IS  TIA  TIB  TIC  TID
	move.l	#%1_00000___0___0_1101_1000_0011_0100_0100_0000,-(sp)
	pflusha
	pmove.l	(sp),tc
;8KBr
	lea.l	$00F00000,a1
	lea.l	$00200000,a0
	move.w	#2048-1,d0
@@:	cmpm.l	(a1)+,(a0)+
	dbne	d0,@b
	bne	@f
	bset.l	#31,d7			;MMU
@@:
;AhXϊ
	bclr.b	#7,(sp)			;E=0
	pmove.l	(sp),tc			;AhXϊ
	pflusha
	lea.l	4+128(sp),sp
	.cpu	68000
	rts

;----------------------------------------------------------------
;MMU`FbN(MC68040/MC68060)
mmuCheck46:
	.cpu	68040
	lea.l	$2000.w,a1
;[ge[u
;			   U W UDT
	lea.l	512|%00000_0_0__10(a1),a0
	moveq.l	#128-1,d0
@@:	move.l	a0,(a1)+
	dbra	d0,@b
;|C^e[u
;			   U W UDT
	lea.l	512|%00000_0_0__10(a1),a0
	moveq.l	#128-1,d0
@@:	move.l	a0,(a1)+
	dbra	d0,@b
;y[We[u
	moveq.l	#32-1,d0
;			    UR G U1 U0 S CM M U W PDT
@@:	move.l	#$00FF0000|%00_1__0__0_0_10_0_0_0__01,(a1)+
	dbra	d0,@b
;$80000000`$FFFFFFFF𓧉ߕϊɂ
;		      BASE     MASK E SFIELD     U1 U0   CM    W
	movea.l	#%00000000_01111111_1_____10_000__0__0_0_10_00_0_00,a1
	movec.l	a1,itt0
	movec.l	a1,dtt0
	movec.l	a1,itt1
	movec.l	a1,dtt1
;AhXϊLɂ
	lea.l	$2000.w,a1
	movec.l	a1,srp			;MMUȂĂG[ɂȂȂ(MC68060UM B.2)
	movec.l	a1,urp
;		  E P NAD NAI FOTC FITC DCO DUO DWO DCI DUI
	movea.l	#%1_1___0___0____0____0__00__00___0__00__00_0,a1
	pflusha
	cinva	bc
	movec.l	a1,tc
;8KBr
	lea.l	$80FF0000,a0
	lea.l	$80F00000,a1
	move.w	#2048-1,d0
@@:	cmpm.l	(a0)+,(a1)+
	dbne	d0,@b
	bne	@f
	bset.l	#31,d7			;MMU
@@:
;AhXϊƃgXyAgϊ
;		  E P NAD NAI FOTC FITC DCO DUO DWO DCI DUI
	movea.l	#%0_0___0___0____0____0__10__00___0__00__00_0,a1
	movec.l	a1,tc
	pflusha
	cinva	bc
	suba.l	a1,a1
	movec.l	a1,itt0
	movec.l	a1,dtt0
	movec.l	a1,itt1
	movec.l	a1,dtt1
	.cpu	68000
	rts

;----------------------------------------------------------------
;ߗO[`
	.cpu	68060
uii:
	pea.l	(8,sp)			;Ossp
	movem.l	d0-d7/a0-a6,-(sp)
	moveq.l	#5,d2			;X[p[oCUf[^ANZX̃t@NVR[h
	btst.b	#5,(4*16,sp)		;OsrS
	bne	1f			;X[p[oCU[h
;[U[h
	moveq.l	#1,d2			;[Uf[^ANZX̃t@NVR[h
	move.l	usp,a0			;Ousp
	move.l	a0,(4*15,sp)		;Osp
;߃R[hǂݎ
1:	movea.l	(4*16+2,sp),a0		;a0=Opc
	move.w	(a0)+,d1		;d1=߃R[h,a1=pc+2
;MOVEPǂׂ
	move.w	d1,d0
;		  0000qqq1ws001rrr
	and.w	#%1111000100111000,d0
	cmp.w	#%0000000100001000,d0
	beq	2f			;MOVEP
;MOVEPȊO
	movem.l	(sp),d0-d2		;d0/d1/d2𕜌
	movea.l	(4*8,sp),a0		;a0𕜌
	lea.l	(4*16,sp),sp		;j󂳂ĂȂWX^̕ȗ
	jmp	$00FF0770		;`O

;MOVEP
;AhX߂
2:	moveq.l	#7,d0			;d0=0000000000000111
	and.w	d1,d0			;d0=0000000000000rrr
	movea.l	(4*8,sp,d0.w*4),a1	;a1=Ar
	adda.w	(a0)+,a1		;a0=pc+4,a1=d16+Ar=AhX
;AAhXXV
	move.l	a0,(4*16+2,sp)		;pc=pc+4
;Dq̃AhX߂
	move.w	d1,d0			;d0=0000qqq1ws001rrr
	lsr.w	#8,d0			;d0=000000000000qqq1
	lea.l	(-2,sp,d0.w*2),a0	;d0*2=00000000000qqq10,a0=Dq̃AhX
;[h/Cg,[h/Oŕ򂷂
	add.b	d1,d1			;c=w,d1=s001rrr0
	bcs	5f			;Cg
;[h
	movec.l	sfc,d1			;t@NVR[hۑ
	movec.l	d2,sfc			;t@NVR[hύX
	bmi	3f			;[hO
;[h[h
;MOVEP.W (d16,Ar),Dq
	moves.b	(a1),d0			;ʃoCg[h
	lsl.w	#8,d0
	moves.b	(2,a1),d0		;牺ʃoCg[h
	move.w	d0,(2,a0)		;f[^WX^̉ʃ[hփCg
	bra	4f

;[hO
;MOVEP.L (d16,Ar),Dq
3:	moves.b	(a1),d0			;ʃ[h̏ʃoCg[h
	lsl.l	#8,d0
	moves.b	(2,a1),d0		;ʃ[h̉ʃoCg[h
	lsl.l	#8,d0
	moves.b	(4,a1),d0		;牺ʃ[h̏ʃoCg[h
	lsl.l	#8,d0
	moves.b	(6,a1),d0		;牺ʃ[h̉ʃoCg[h
	move.l	d0,(a0)			;f[^WX^փCg
4:	movec.l	d1,sfc			;t@NVR[h𕜌
	movem.l	(sp),d0-d7		;f[^WX^̂ǂꂩ1XVĂ
	bra	8f

;Cg
5:	movec.l	dfc,d1			;t@NVR[hۑ
	movec.l	d2,dfc			;t@NVR[hύX
	bmi	6f			;CgO
;Ch[h
;MOVEP.W Dq,(d16,Ar)
	move.w	(2,a0),d0		;f[^WX^̉ʃ[h烊[h
	rol.w	#8,d0
	moves.b	d0,(a1)			;֏ʃoCgCg
	rol.w	#8,d0
	moves.b	d0,(2,a1)		;։ʃoCgCg
	bra	7f

;CgO
;MOVEP.L Dq,(d16,Ar)
6:	move.l	(a0),d0			;f[^WX^烊[h
	rol.l	#8,d0
	moves.b	d0,(a1)			;֏ʃ[h̏ʃoCgCg
	rol.l	#8,d0
	moves.b	d0,(2,a1)		;֏ʃ[h̉ʃoCgCg
	rol.l	#8,d0
	moves.b	d0,(4,a1)		;։ʃ[h̏ʃoCgCg
	rol.l	#8,d0
	moves.b	d0,(6,a1)		;։ʃ[h̉ʃoCgCg
7:	movec.l	d1,dfc			;t@NVR[h𕜌
	movem.l	(sp),d0-d2		;d0/d1/d2𕜌
8:	movem.l	(4*8,sp),a0-a1		;a0/a1𕜌
	lea.l	(4*16,sp),sp		;j󂳂ĂȂWX^̕ȗ
	tst.b	(sp)			;OsrT
	bpl	9f			;g[XȂ
;g[X
	ori.w	#$8000,sr		;RTȆOsrTZbgMOVEPg[X悤ɐU镑
9:
;ߗO[`rte
uii_rte:
	rte

	.cpu	68000

	PATCH_END



  .if 0
;SASI@̂ƂIOCS _SCSIDRV̓G[Ԃ

;----------------------------------------------------------------
;
;	SASI@̂ƂIOCS _SCSIDRVo^Ȃ
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF00C4 203900FF934E           move.l	$00FF934E,d0
;		00FF00CA 21C007D4               move.l	d0,$07D4.w
;		00FF00CE
;----------------------------------------------------------------

	PATCH_DATA	init_iocs_scsidrv,$00FF00C4,$00FF00CE,$203900FF

	jsr	init_iocs_scsidrv
	movea.l	a0,a0
	movea.l	a0,a0

	PATCH_TEXT

init_iocs_scsidrv:
	cmpi.b	#$FF,$00E9602D		;$FF=SASI@,̑=SCSI@
	beq	@f
	move.l	$00FF934E,d0
	move.l	d0,$07D4.w
@@:	rts

	PATCH_END

  .endif



;----------------------------------------------------------------
;
;	NbNv
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF013C 0C3800010CBC           cmpi.b	#$01,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
;			:
;		00FF019C
;----------------------------------------------------------------

	PATCH_DATA	clockCheck,$00FF013C,$00FF019C,$0C380001

	jsr	clockCheck
	bra	($00FF019C)PATCH_ZL

	PATCH_TEXT

;----------------------------------------------------------------
;NbNv
clockCheck:

;VXeNbN̊mF
	moveq.l	#0,d0
	move.b	$00E8E00B,d0		;[$00E8E00B].b:SYS @픻($DC=X68030,$FE=XVI16MHz,$FF=XVIȑO10MHz)
					;$00FF=10MHz,$00FE=16MHz,$00DC=25MHz
	not.b	d0			;$0000=10MHz,$0001=16MHz,$0023=25MHz
	lsl.w	#4,d0			;$0000=10MHz,$0010=16MHz,$0230=25MHz
	lsr.b	#4,d0			;$0000=10MHz,$0001=16MHz,$0203=25MHz
	move.w	d0,$0CB6.w		;[$0CB6.w].w:[11,12,13]VXeNbN($0000=10MHz,$0001=16MHz,$0203=25MHz)

;NbNv̂߂̃LbVON
;	MC68030̂Ƃ͖߃LbVƃf[^LbVONɂ
;	MC68040/MC68060̃f[^LbVMC68060̃XgAobt@MMULɂ܂ONɂłȂ̂Ŗ߃LbVONɂ
;	SRAM̃LbV̐ݒ͂Ŕf
	cmpi.b	#2,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	blo	3f			;MC68000/MC68010̓LbVȂ
	move.l	#$00002101,d0		;MC68020͖߃LbVON(bit0)AMC68030̓f[^LbVON(bit8),߃LbVON(bit0)
	cmpi.b	#4,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	blo	2f			;MC68020/MC68030
	beq	1f			;MC68040
	.cpu	68060
	movec.l	pcr,d0
	bset.l	#0,d0			;MC68060̓X[p[XJON(bit0)
	movec.l	d0,pcr
	.cpu	68000
	move.l	#$00800000,d0		;MC68060̓XgAobt@OFF(bit29),LbVON(bit23)
1:	move.w	#$8000,d0		;MC68040/MC68060̓f[^LbVOFF(bit31),߃LbVON(bit15)
2:
	.cpu	68030
	movec.l	d0,cacr
	.cpu	68000
	clr.b	$00E8E009		;[$00E8E009].b:[X68030]ANZXEFCg
3:

;NbNv
;ROMv
	lea.l	clockLoop(pc),a0	;v[v
	bsr	clockSub		;vTu
	move.w	d0,$0CB8.w		;[$0CB8.w].w:[11,12,13]ROMvNbN($034210*250/3,$056E16.67*250/3,$104D25*500/3)
;RAMv
	lea.l	-30(sp),sp
	move.l	sp,d0
	add.w	#14,d0
	and.w	#-16,d0			;16oCgEn܂16oCg̃[NGA
	addq.w	#4,d0
	movea.l	d0,a0			;v[v
	move.l	clockLoop-4(pc),-4(a0)	;v[v[NGAɃRs[
	move.l	clockLoop(pc),(a0)
	move.l	clockLoop+4(pc),4(a0)
	move.l	clockLoop+8(pc),8(a0)	;X^bNGA߃LbVɏĂ邱Ƃ͂Ȃ̂ŃLbVtbV͏ȗ
	bsr	clockSub		;vTu
	lea.l	30(sp),sp
	move.w	d0,$0CBA.w		;[$0CBA.w].w:[11,12,13]RAMvNbN($03D310*250/3*1.2/(1+0.22/10),$066D16.67*250/3*1.2/(1+0.22/16.67),$104D25*500/3)
	rts

;vTu
;>d0.w:vlB0=s
;?d1-d2/a1
clockSub:
;񐔏
	moveq.l	#22-8,d2
clockRetry:
;荞݋֎~
	move.w	sr,-(sp)
	ori.w	#$0700,sr
;^C}ۑ
	lea.l	TCDCR,a1
	move.b	IERB-TCDCR(a1),-(sp)
	move.b	IMRB-TCDCR(a1),-(sp)
	move.b	TCDCR-TCDCR(a1),-(sp)
;^C}ݒ
	andi.b	#%11001111,IERB-TCDCR(a1)	;Timer-C/D荞ݒ~
	andi.b	#%11001111,IMRB-TCDCR(a1)	;Timer-C/D荞݋֎~
	move.b	#$00,TCDCR-TCDCR(a1)	;Timer-C/DJEg~
@@:	tst.b	TCDCR-TCDCR(a1)		;Sɒ~܂ő҂
	bne	@b
	move.b	#$00,TCDR-TCDCR(a1)	;Timer-CJE^NA
	move.b	#$00,TDDR-TCDCR(a1)	;Timer-DJE^NA
;
	move.l	#1<<22,d0
	lsr.l	d2,d0
	subq.l	#1,d0
;JEgJn
;		  TCCR TDCR
	move.b	#%0111_0001,TCDCR-TCDCR(a1)	;Timer-C/DJEgJn
					;	Timer-C1/200vXP[(50s)
					;	Timer-D1/4vXP[(1s)
;v
	jsr	(a0)
;JEg~
	move.b	#$00,TCDCR-TCDCR(a1)	;Timer-C/DJEg~
@@:	tst.b	TCDCR-TCDCR(a1)		;Sɒ~܂ő҂
	bne	@b
;^C}擾
	moveq.l	#0,d0
	sub.b	TCDR-TCDCR(a1),d0	;Timer-CJEg
	moveq.l	#0,d1
	sub.b	TDDR-TCDCR(a1),d1	;Timer-DJEg(I[o[t[)
;^C}
	move.b	#200,TCDR-TCDCR(a1)	;Timer-CJE^
	move.b	#$00,TDDR-TCDCR(a1)	;Timer-DJE^NA
	move.b	(sp)+,TCDCR-TCDCR(a1)
	move.b	(sp)+,IMRB-TCDCR(a1)
	move.b	(sp)+,IERB-TCDCR(a1)
;荞݋
	move.w	(sp)+,sr
;JE^
	mulu.w	#50,d0
	cmp.b	d1,d0
	bls	@f
	add.w	#256,d0
@@:	move.b	d1,d0
	subq.w	#1,d0
;񐔍XV
	tst.w	d2
	beq	@f
	cmp.w	#5000,d0
	bcc	@f
	subq.w	#1,d2			;5000sɖȂΉ񐔂2{ɂ
	bra	clockRetry

@@:
;␳
	lea.l	clockScale(pc),a1
	moveq.l	#0,d1
	move.b	$0CBC.w,d1		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	cmp.w	#6,d1
	bhi	@f			;Ô
	lsl.w	#2,d1
	adda.w	d1,a1
@@:	move.l	(a1),d1
	lsr.l	d2,d1			;699050667>>(22-18)
	tst.l	d0
	beq	9f
	cmp.l	#$FFFF,d0
	bhi	9f
	divu.w	d0,d1			;(699050667>>(22-18))/5243
	bvc	@f
	moveq.l	#-1,d1			;I[o[t[
@@:	moveq.l	#0,d0
	move.w	d1,d0
	rts

9:	moveq.l	#0,d0			;s
	rts

;  +-----------+---+-------+---------+----+--------+-----+------------------------+-----------------------------------------+-----------------------+
;  |           |c/n|   f   |u/n=c/n/f|  n | u=u/n*n|  J  |      K=c/n/J*2^22      |             CB8=K/(2^22/n)/u            |        f=CB8*J        |
;  +-----------+---+-------+---------+----+--------+-----+------------------------+-----------------------------------------+-----------------------+
;  |68000/68010| 12| 10.000|  1.200  |2^13|9830.400|0.012|4194304000=12/0.012*2^22|  833.333=4194304000/(2^22/2^13)/9830.400| 10.000=  833.333*0.012|
;  |           |   | 16.667|  0.720  |2^13|5898.240|     |                        | 1388.889=4194304000/(2^22/2^13)/5898.240| 16.667= 1388.889*0.012|
;  |           |   | 25.000|  0.480  |2^14|7864.320|     |                        | 2083.333=4194304000/(2^22/2^14)/7864.320| 25.000= 2083.333*0.012|
;  |           |   | 33.333|  0.360  |2^14|5898.240|     |                        | 2777.778=4194304000/(2^22/2^14)/5898.240| 33.333= 2777.778*0.012|
;  |           |   | 50.000|  0.240  |2^15|7864.320|     |                        | 4166.667=4194304000/(2^22/2^15)/7864.320| 50.000= 4166.667*0.012|
;  |           |   | 66.666|  0.180  |2^15|5898.240|     |                        | 5555.556=4194304000/(2^22/2^15)/5898.240| 66.667= 5555.556*0.012|
;  |           |   |100.000|  0.120  |2^16|7864.320|     |                        | 8333.333=4194304000/(2^22/2^16)/7864.320|100.000= 8333.333*0.012|
;  |           |   |750.000|  0.016  |2^19|8388.608|     |                        |62500.000=4194304000/(2^22/2^19)/8388.608|750.000=62500.000*0.012|
;  +-----------+---+-------+---------+----+--------+-----+------------------------+-----------------------------------------+-----------------------+
;  |68020/68030|  6| 25.000|  0.240  |2^15|7864.320|0.006|4194304000= 6/0.006*2^22| 4166.667=4194304000/(2^22/2^15)/7864.320| 25.000= 4166.667*0.006|
;  |           |   | 33.333|  0.180  |2^15|5898.240|     |                        | 5555.556=4194304000/(2^22/2^15)/5898.240| 33.333= 5555.556*0.006|
;  |           |   | 50.000|  0.120  |2^16|7864.320|     |                        | 8333.333=4194304000/(2^22/2^16)/7864.320| 50.000= 8333.333*0.006|
;  |           |   |375.000|  0.016  |2^19|8388.608|     |                        |62500.000=4194304000/(2^22/2^19)/8388.608|375.000=62500.000*0.006|
;  +-----------+---+-------+---------+----+--------+     +------------------------+-----------------------------------------+-----------------------+
;  |   68040   |  4| 25.000|  0.160  |2^15|5242.880|     |2796202667= 4/0.006*2^22| 4166.667=2796202667/(2^22/2^15)/5242.880| 25.000= 4166.667*0.006|
;  +-----------+---+-------+---------+----+--------+     +------------------------+-----------------------------------------+-----------------------+
;  |   68060   |  1| 33.333|  0.030  |2^18|7864.320|     | 699050667= 1/0.006*2^22| 5555.556= 699050667/(2^22/2^18)/7864.320| 33.333= 5555.556*0.006|
;  |           |   | 50.000|  0.020  |2^18|5242.880|     |                        | 8333.333= 699050667/(2^22/2^18)/5242.880| 50.000= 8333.333*0.006|
;  |           |   | 66.667|  0.015  |2^19|7864.320|     |                        |11111.111= 699050667/(2^22/2^19)/7864.320| 66.667=11111.111*0.006|
;  |           |   | 75.000|  0.013  |2^19|6990.507|     |                        |12500.000= 699050667/(2^22/2^19)/6990.507| 75.000=12500.000*0.006|
;  +-----------+---+-------+---------+----+--------+-----+------------------------+-----------------------------------------+-----------------------+
;  }
;    c/n  dbra[v1̃TCN
;    f    g(MHz)
;    u/n  dbra[v1̏v(}CNb)
;    n    dbra[v񐔁B2̗ݏu5000ȏ10000ɂȂ悤ɒ
;    u    dbra[vn̏v(}CNb)
;    J    68000/68010̂Ƃ0.012A68020/68030/68030/680600.006
;         dbraŕ򂷂Ƃ̃TCN6800012TCNA680306TCNł邱ƂɗR
;    K    c/n/J*2^22Be[uoB2^22K2^32ōőɂČ덷炷߂̌W
;    CB8  [$0CB8].w̒lBROMŌvgBX68000f*250/3AX68030f*500/3B12{܂6{邱Ƃf*1000Ƃėp
;  ⑫
;    68000/68010dbra10TCNROM̂Ƃ̓EGCĝ12TCNɂȂ
;    RAM̂ƂDRAM̃tbV̉e(1+0.22/f){炢ɂȂ

;v[v
	.align	4		;dbra4oCgEɍ킹
	nop
@@:	swap.w	d0
clockLoop:
	dbra	d0,clockLoop
	swap.w	d0
	dbra	d0,@b
	rts			;ʃ[hƉʃ[hւ܂܂-1Ȃ̂ŖȂ

	.align	4
clockScale:
	.dc.l	4194304000	;68000
	.dc.l	4194304000	;68010
	.dc.l	4194304000	;68020
	.dc.l	4194304000	;68030
	.dc.l	2796202667	;68040
	.dc.l	0
	.dc.l	699050667	;68060

	PATCH_END



;----------------------------------------------------------------
;
;	MC68000̂ƂGAZbg̃|[g[h悤ƂċNłȂ
;
;	ROM 1.2܂MOVE.B $00,$00E86001Ƃ낪ROM 1.3CLR.B $00E86001ɕύXꂽ
;	MC68000CLR.B̓Cg̑OɃ[h
;	GAZbg̃|[g$00E86001͐^ɃCgI[Ń[hƃoXG[ɂȂ
;	MC68000łCLR.B $00E86001oXG[ɂȂ
;	X68000X68030ROM悹ƋNłȂ1
;	G~[^CLR.B̃[hȗĂꍇ͋Nł
;
;	SF.B[ĥCLR.BSF.BɕύXĂʖ
;	ÕA[N̏$00FF05BE畜AƂA0͏RTC̃AhX$00E8A000wĂ̂łg
;
;	Ql
;		ӂĂ̈A̍l@
;		https://twitter.com/futtyt/status/1332591514963197953
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF01B2  423900E86001          clr.b   $00E86001
;		00FF01B8
;----------------------------------------------------------------

	PATCH_DATA	areaSet,$00FF01B2,$00FF01B8,$423900E8

;<a0.l:$00E8A000
	move.b	#$00,$00E86001-$00E8A000(a0)

	PATCH_END



;----------------------------------------------------------------
;
;	LCDΉL[
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF0252  7213                  moveq.l	#$13,d1
;		00FF0254  43F80800              lea.l	$0800.w,a1
;		00FF0258  082900050005          btst.b	#$05,$0005(a1)		;VL[
;		00FF025E  660A                  bne.s	$00FF026A
;		00FF0260  7210                  moveq.l	#$10,d1
;		00FF0262  082900070005          btst.b	#$07,$0005(a1)		;NL[
;		00FF0268  6718                  beq.s	$00FF0282
;		00FF026A  13FC003100E8E00D      move.b	#$31,$00E8E00D		;SRAM݋
;		00FF0272  13C100ED001D          move.b	d1,$00ED001D		;N̉ʃ[h
;		00FF0278  423900E8E00D          clr.b	$00E8E00D		;SRAM݋֎~
;		00FF027E  70104E4F              IOCS	_CRTMOD
;		00FF0282
;----------------------------------------------------------------

	PATCH_DATA	lcdKey,$00FF0252,$00FF0282,$721343F8

	jsr	lcdKey
	bra	($00FF0282)PATCH_ZL

	PATCH_TEXT

lcdKey:
	move.w	#$4300+16,d1		;ʃ[h16(768x512)CRT
	btst.b	#7,$0805.w		;NL[
	bne	1f			;ĂBݒ肷
	move.w	#$4C00+16,d1		;ʃ[h16(768x512)LCD
	btst.b	#6,$0804.w		;LL[
	bne	1f			;ĂBݒ肷
	move.w	#$4C00+19,d1		;ʃ[h19(640x480)LCD
	btst.b	#5,$0805.w		;VL[
	beq	2f			;ĂȂBݒ肵ȂBI
;ݒ肷
1:	____SRAM_WRITABLE____
	move.b	d1,$00ED001D		;N̉ʃ[h
	____SRAM_READONLY____
	IOCS	_CRTMOD
;I
2:	rts

	PATCH_END



;----------------------------------------------------------------
;
;	NbZ[WȂł
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF02B2 43FA08D4               lea.l	$00FF0B88(pc),a1	;$1A
;		00FF02B6 61000470               bsr.w	$00FF0728		;\
;		00FF02BA
;----------------------------------------------------------------

	PATCH_DATA	notClearMessage,$00FF02B2,$00FF02BA,$43FA08D4

	bra	($00FF02BA)PATCH_ZL

	PATCH_END



;----------------------------------------------------------------
;
;	XF3,XF4,XF5ȂNƂ̃LbVOFF
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF0336 7000                   moveq.l	#$00,d0
;		00FF0338 4E7B0002               movec.l	d0,cacr			;LbVOFF
;		00FF033C
;----------------------------------------------------------------

	PATCH_DATA	xf345CacheOff,$00FF0336,$00FF033C,$70004E7B

	jsr	cacheOff		;LbVOFF

	PATCH_END



;----------------------------------------------------------------
;
;	XF1,XF2ȂNƂ̃LbVOFF
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF0380 7000                   moveq.l	#$00,d0
;		00FF0382 4E7B0002               movec.l	d0,cacr			;LbVOFF
;		00FF0386
;----------------------------------------------------------------

	PATCH_DATA	xf12CacheOff,$00FF0380,$00FF0386,$70004E7B

	jsr	cacheOff		;LbVOFF

	PATCH_END



;----------------------------------------------------------------
;
;	NbZ[W
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF0E88 61000182               bsr.w	$00FF100C		;ROM̃o[W\
;		00FF0E8C 615C                   bsr.s	$00FF0EEA		;MPU̎ނƓg\
;		00FF0E8E 610000EE               bsr.w	$00FF0F7E		;FPU/FPCP̗L\
;		00FF0E92 610000F8               bsr.w	$00FF0F8C		;MMU̗L\
;		00FF0E96 61000104               bsr.w	$00FF0F9C		;C̃TCY\
;		00FF0E9A
;----------------------------------------------------------------

	PATCH_DATA	iplMessage,$00FF0E88,$00FF0E9A,$61000182

	jsr	iplMessage
	bra	($00FF0E9A)PATCH_ZL

	PATCH_TEXT

;----------------------------------------------------------------
;NbZ[W\
iplMessage:
	movem.l	d0-d7/a0-a6,-(sp)
	lea.l	-128(sp),sp
	movea.l	sp,a6			;obt@
;<a6.l:obt@
;bZ[W
	bsr	iplMessageRomver	;ROM̃o[W\
	bsr	iplMessageMpu		;MPU̎ނƓg\
	bsr	iplMessageFpu		;FPU/FPCP̗LƎނ\
	bsr	iplMessageMmu		;MMU̗L\
	bsr	iplMessageMemory	;C͈̔͂Ɨeʂ\
	bsr	iplMessageExmemory	;g͈̔͂Ɨeʂ\
	bsr	iplMessageCoprocessor	;RvZbT̗LƎނ\
;eLXgJ[\4sڂɈړ
	moveq.l	#-1,d1
	moveq.l	#-1,d2
	IOCS	_B_CONSOL
;<d0.l:0
;<d1.l:eLXg\JnXhbgW*$10000+eLXg\JnYhbgW
;<d2.l:(eLXg\-1)*$10000+(eLXg\s-1)
	clr.w	d1
	subq.w	#3,d2			;4s
;<d1.w:eLXgJ[\XW
;<d2.w:eLXgJ[\YW
	IOCS	_B_LOCATE
	lea.l	128(sp),sp
	movem.l	(sp)+,d0-d7/a0-a6
	rts

;----------------------------------------------------------------
;ROM̃o[W\
;<a6.l:obt@
;?d0-d1/a0-a1
iplMessageRomver:
	movea.l	a6,a0			;obt@
	lea.l	100f(pc),a1		;$1B,'[1mBIOS ROM version: '
	bsr	strCopy
	IOCS	_ROMVER
;BCDϊ
	move.l	d0,d1			;abcdefgh
	clr.w	d0			;abcd0000
	sub.l	d0,d1			;0000efgh
	swap.w	d0			;0000abcd
	lsl.l	#4,d0			;000abcd0
	lsl.l	#4,d1			;000efgh0
	lsr.w	#4,d0			;000a0bcd
	lsr.w	#4,d1			;000e0fgh
	lsl.l	#8,d0			;0a0bcd00
	lsl.l	#8,d1			;0e0fgh00
	lsr.w	#4,d0			;0a0b0cd0
	lsr.w	#4,d1			;0e0f0gh0
	lsr.b	#4,d0			;0a0b0c0d
	lsr.b	#4,d1			;0e0f0g0h
	or.l	#$30303030,d0		;3a3b3c3d
	or.l	#$30303030,d1		;3e3f3g3h
;o[W
	rol.l	#8,d0
	move.b	d0,(a0)+
	move.b	#'.',(a0)+
	rol.l	#8,d0
	move.b	d0,(a0)+
;t
	lea.l	101f(pc),a1		;' (20'
	bsr	strCopy
	rol.l	#8,d0
	move.b	d0,(a0)+
	rol.l	#8,d0
	move.b	d0,(a0)+
	move.b	#'-',(a0)+
	rol.l	#8,d1
	move.b	d1,(a0)+
	rol.l	#8,d1
	move.b	d1,(a0)+
	move.b	#'-',(a0)+
	rol.l	#8,d1
	move.b	d1,(a0)+
	rol.l	#8,d1
	move.b	d1,(a0)+
	lea.l	102f(pc),a1		;')',$1B,'[1m',13,10
	bsr	strCopy
	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
	rts

100:	.dc.b	$1B,'[1m'
;		           111111111122222222223333333333
;		 0123456789012345678901234567890123456789
	.dc.b	'                 BIOS ROM version : ',0
101:	.dc.b	' (20',0
102:	.dc.b	')',$1B,'[1m',13,10,0
	.even

;----------------------------------------------------------------
;MPU̎ނƓg\
;<a6.l:obt@
;>d5.l:_SYS_STAT(0)̌
;	bit0`7		MPU̎(0=MC68000,3=68030,4=68040,6=68060)
;	bit14		MMU̗L(0=Ȃ,1=)
;	bit15		FPU/FPCP̗L(0=Ȃ,1=)
;	bit16`31	g(MHz)*10
;?d0-d1/a0-a1
iplMessageMpu:
	moveq.l	#0,d1
	IOCS	_SYS_STAT
	move.l	d0,d5
;<d5.l:_SYS_STAT(0)̌
;	bit0`7		MPU̎(0=MC68000,3=68030,4=68040,6=68060)
;	bit14		MMU̗L(0=Ȃ,1=)
;	bit15		FPU/FPCP̗L(0=Ȃ,1=)
;	bit16`31	g(MHz)*10
	movea.l	a6,a0			;obt@
	lea.l	100f(pc),a1		;'Micro-Processing Unit (MPU): '
	bsr	strCopy
;MPU̎
;	MCXC
;		MC68000/MC68010/MC68020/MC68030/MC68040MC
;		MC68060̓rW6MCArW5܂XC
;			http://www.ppa.pl/forum/amiga/29981/68060-pcr
;			?	rW0
;			F43G	rW1
;			G65V	rW5
;			G59Y	?
;			E41J	rW6
;	LCEC
;		MC68000/MC68010/MC68020͖
;		MC68030MMUƂAMMUȂƂEC
;		MC68040/MC68060FPUƂAFPUȂMMUƂLCAMMUȂƂEC
;	rWio[
;		MC68060̂Ƃ-0XXŃrWio[\
;	
;		MC68EC020MC68020̃AhXoX24bitɂECS,OCS,DBEN,IPEND,BGACKȗgݍݗpBRvZbTC^tFCX͋
	moveq.l	#-1,d2			;rWio[B-1=rWio[\Ȃ
	moveq.l	#'M',d1
	cmp.b	#6,d5
	bne	1f			;MC68000/MC68030/MC68040MC
	.cpu	68060
	movec.l	pcr,d0
	.cpu	68000
	lsr.w	#8,d0
	moveq.l	#0,d2
	move.b	d0,d2			;rWio[
	cmp.b	#6,d2
	bcc	1f			;MC68060̃rW6ȏMC
	moveq.l	#'X',d1			;MC68060̃rW5ȉXC
1:	move.b	d1,(a0)+
	lea.l	101f(pc),a1		;'C68',0
	bsr	strCopy
	cmp.b	#3,d5
	blo	5f			;MC68000/MC68010/MC68020͖
	bhi	2f
	btst.l	#14,d5
	bne	5f			;MC68030MMUƂ
	bra	3f			;MC68030MMUȂƂEC

2:	tst.w	d5
	bmi	5f			;MC68040/MC68060FPUƂ
	moveq.l	#'L',d1
	btst.l	#14,d5
	bne	4f			;MC68040/MC68060FPUȂMMUƂLC
3:	move.l	#'E',d1			;MC68040/MC68060MMUȂƂEC
4:	move.b	d1,(a0)+
	move.b	#'C',(a0)+
5:	move.b	#'0',(a0)+
	moveq.l	#'0',d1
	add.b	d5,d1
	move.b	d1,(a0)+
	move.b	#'0',(a0)+
	move.l	d2,d0			;rWio[
	bmi	6f
	move.b	#'-',(a0)+
	moveq.l	#3,d1
	bsr	strDecN
6:
;g
	move.b	#' ',(a0)+
	move.b	#'(',(a0)+
	move.l	d5,d0
	clr.w	d0
	swap.w	d0			;g(MHz)*10
	bsr	strDec
	move.b	-1(a0),(a0)+		;_ȉ1ڂɂ炷
	move.b	#'.',-2(a0)		;_
	lea.l	102f(pc),a1		;'MHz)',13,10
	bsr	strCopy
	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
	rts

;		           111111111122222222223333333333
;		 0123456789012345678901234567890123456789
100:	.dc.b	'      Micro-Processing Unit (MPU) : ',0
101:	.dc.b	'C68',0
102:	.dc.b	'MHz)',13,10,0
	.even

;----------------------------------------------------------------
;FPU/FPCP̗LƎނ\
;	MC68030
;	  fnop
;	    fmovecr.x #1,fp00		Floating-Point Coprocessor (FPCP): MC68881
;	    fmovecr.x #1,fp00ȊO	Floating-Point Coprocessor (FPCP): MC68882
;	MC68040,MC68060
;	  fnop			Floating-Point Unit (FPU): on MPU
;<d5.l:_SYS_STAT(0)̌
;	bit0`7		MPU̎(0=MC68000,3=68030,4=68040,6=68060)
;	bit14		MMU̗L(0=Ȃ,1=)
;	bit15		FPU/FPCP̗L(0=Ȃ,1=)
;	bit16`31	g(MHz)*10
;<a6.l:obt@
;?d0/a0-a1
iplMessageFpu:
;FPU/FPCP
	tst.w	d5
	bpl	3f			;FPU/FPCPȂ
	movea.l	a6,a0			;obt@
	lea.l	100f(pc),a1		;'Floating-Point Unit (FPU): '
	cmp.b	#4,d5
	bhs	1f
	lea.l	101f(pc),a1		;'Floating-Point Coprocessor (FPCP): '
1:	bsr	strCopy
	lea.l	102f(pc),a1		;'on MPU',13,10
	cmp.b	#4,d5
	bhs	2f			;MC68040/MC68060
	.cpu	68030
	fmovecr.x	#1,fp0		;0=MC68881,0ȊO=MC68882
	fmove.x	fp0,-(sp)
	.cpu	68000
	move.l	(sp)+,d0
	or.l	(sp)+,d0
	or.l	(sp)+,d0
	lea.l	103f(pc),a1		;'MC68881',13,10
	beq	2f
	lea.l	104f(pc),a1		;'MC68882',13,10
2:	bsr	strCopy
	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
3:
	rts

;		           111111111122222222223333333333
;		 0123456789012345678901234567890123456789
100:	.dc.b	'        Floating-Point Unit (FPU) : ',0
101:	.dc.b	'Floating-Point Coprocessor (FPCP) : ',0
102:	.dc.b	'on MPU',13,10,0
103:	.dc.b	'MC68881',13,10,0
104:	.dc.b	'MC68882',13,10,0
	.even

;----------------------------------------------------------------
;RvZbT̗LƎނ\
;	MC68040,MC68060
;	  FC=7$00022000CIR
;	    fmovecr.x #1,fp00		Motherboard Coprocessor: MC68881
;	    fmovecr.x #1,fp00ȊO	Motherboard Coprocessor: MC68882
;	MC68000,MC68030,MC68040,MC68060
;	  $00E9E000CIR
;	    fmovecr.x #1,fp00		Extension Board Coprocessor 1: MC68881
;	    fmovecr.x #1,fp00ȊO	Extension Board Coprocessor 1: MC68882
;	  $00E9E080CIR
;	    fmovecr.x #1,fp00		Extension Board Coprocessor 2: MC68881
;	    fmovecr.x #1,fp00ȊO	Extension Board Coprocessor 2: MC68882
iplMessageCoprocessor:
;}U[{[hRvZbT
	cmp.b	#4,d5
	blo	2f
	bsr	coproCheck1		;}U[{[hRvZbT̗LƎނ𒲂ׂ
	bmi	2f
	movea.l	a6,a0			;obt@
	lea.l	105f(pc),a1		;'Motherboard Coprocessor: '
	bsr	strCopy
	tst.l	d0
	lea.l	103f(pc),a1		;'MC68881',13,10
	beq	1f
	lea.l	104f(pc),a1		;'MC68882',13,10
1:	bsr	strCopy
	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
2:
;lZvZbT{[h1
	moveq.l	#0,d0
	bsr	coproCheck2
	bmi	2f
	movea.l	a6,a0			;obt@
	lea.l	106f(pc),a1		;'Extension Board Coprocessor 1: '
	bsr	strCopy
	tst.l	d0
	lea.l	103f(pc),a1		;'MC68881',13,10
	beq	1f
	lea.l	104f(pc),a1		;'MC68882',13,10
1:	bsr	strCopy
	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
2:
;lZvZbT{[h2
	moveq.l	#1,d0
	bsr	coproCheck2
	bmi	2f
	movea.l	a6,a0			;obt@
	lea.l	107f(pc),a1		;'Extension Board Coprocessor 2: '
	bsr	strCopy
	tst.l	d0
	lea.l	103f(pc),a1		;'MC68881',13,10
	beq	1f
	lea.l	104f(pc),a1		;'MC68882',13,10
1:	bsr	strCopy
	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
2:
	rts

103:	.dc.b	'MC68881',13,10,0
104:	.dc.b	'MC68882',13,10,0
;		           111111111122222222223333333333
;		 0123456789012345678901234567890123456789
105:	.dc.b	'          Motherboard Coprocessor : ',0
106:	.dc.b	'    Extension Board Coprocessor 1 : ',0
107:	.dc.b	'    Extension Board Coprocessor 2 : ',0
	.even

;}U[{[hRvZbT̗LƎނ𒲂ׂ
;>d0.l:-1=Ȃ,0=MC68881,1=MC68882
	.cpu	68060
coproCheck1:
	movem.l	d1-d4/a0-a2,-(sp)
@@:	moveq.l	#1,d0
	and.b	@b-1(pc,d0.w*2),d0	;0=000,1=020ȏ
	subq.l	#1,d0			;-1=000,0=020ȏ
	bmi	9f			;000
	lea.l	$00022000,a0
	moveq.l	#-1,d0
	move.w	sr,d2
	ori.w	#$0700,sr
	movec.l	dfc,d4
	movec.l	sfc,d3
	moveq.l	#7,d1			;CPU
	movec.l	d1,dfc
	movec.l	d1,sfc
	lea.l	5f(pc),a1
	movea.l	$0008.w,a2
	move.l	a1,$0008.w
	movea.l	sp,a1
	clr.w	d1			;null
	moves.w	d1,$06(a0)		;restore
	moves.w	$06(a0),d1		;restore
@@:	moves.w	(a0),d1			;response
	cmp.w	#$0802,d1		;idle
	bne	@b
	move.w	#$5C01,d1		;fmovecr.x #$01,fp0
	moves.w	d1,$0A(a0)		;command
@@:	moves.w	(a0),d1			;response
	cmp.w	#$0802,d1		;idle
	bne	@b
	move.w	#$6800,d1		;fmove.x fp0,<mem>
	moves.w	d1,$0A(a0)		;command
@@:	moves.w	(a0),d1			;response
	cmp.w	#$320C,d1		;extended to mem
	bne	@b
	moves.l	$10(a0),d0		;operand
	moves.l	$10(a0),d1		;operand
	or.l	d1,d0
	moves.l	$10(a0),d1		;operand
	or.l	d1,d0
	beq	@f			;ROM$010Ȃ̂MC68881
	moveq.l	#1,d0			;ROM$010łȂ̂MC68882
@@:
5:	movea.l	a1,sp
	move.l	a2,$0008.w
	movec.l	d3,sfc
	movec.l	d4,dfc
	move.w	d2,sr
9:	movem.l	(sp)+,d1-d4/a0-a2
	tst.l	d0
	rts

	.cpu	68000

;lZvZbT{[h̗LƎނ𒲂ׂ
;<d0.l:0=lZvZbT{[h1,1=lZvZbT{[h2
;>d0.l:-1=Ȃ,0=MC68881,1=MC68882
coproCheck2:
	movem.l	d1-d2/a0-a2,-(sp)
	lea.l	$00E9E000,a0
	tst.l	d0
	beq	@f
	lea.l	$80(a0),a0
@@:	moveq.l	#-1,d0
	move.w	sr,d2
	ori.w	#$0700,sr
	lea.l	5f(pc),a1
	movea.l	$0008.w,a2
	move.l	a1,$0008.w
	movea.l	sp,a1
	clr.w	$06(a0)			;restore,null
	tst.w	$06(a0)			;restore
@@:	cmpi.w	#$0802,(a0)		;response,idle
	bne	@b
	move.w	#$5C01,$0A(a0)		;command,fmovecr.x #$01,fp0
@@:	cmpi.w	#$0802,(a0)		;response,idle
	bne	@b
	move.w	#$6800,$0A(a0)		;command,fmove.x fp0,<mem>
@@:	cmpi.w	#$320C,(a0)		;response,extended to mem
	bne	@b
	move.l	$10(a0),d0		;operand
	move.l	$10(a0),d1		;operand
	or.l	d1,d0
	move.l	$10(a0),d1		;operand
	or.l	d1,d0
	beq	@f			;ROM$010Ȃ̂MC68881
	moveq.l	#1,d0			;ROM$010łȂ̂MC68882
@@:
5:	movea.l	a1,sp
	move.l	a2,$0008.w
	move.w	d2,sr
	movem.l	(sp)+,d1-d2/a0-a2
	tst.l	d0
	rts

;----------------------------------------------------------------
;MMU̗L\
;<d5.l:_SYS_STAT(0)̌
;	bit0`7		MPU̎(0=MC68000,3=68030,4=68040,6=68060)
;	bit14		MMU̗L(0=Ȃ,1=)
;	bit15		FPU/FPCP̗L(0=Ȃ,1=)
;	bit16`31	g(MHz)*10
;<a6.l:obt@
;?d0/a0-a1
iplMessageMmu:
	btst.l	#14,d5
	beq	9f			;MMUȂ
	movea.l	a6,a0			;obt@
	lea.l	100f(pc),a1		;'Memory Management Unit (MMU): '
	bsr	strCopy
	cmp.b	#3,d5
	bhs	1f
	lea.l	101f(pc),a1		;'MC68851',13,10
	bsr	strCopy
	bra	2f

1:	lea.l	102f(pc),a1		;'on MPU',13,10
	bsr	strCopy
2:	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
9:	rts

;		           111111111122222222223333333333
;		 0123456789012345678901234567890123456789
100:	.dc.b	'     Memory Management Unit (MMU) : ',0
101:	.dc.b	'MC68851',13,10,0
102:	.dc.b	'on MPU',13,10,0
	.even

;----------------------------------------------------------------
;C͈̔͂Ɨeʂ\
;	$00100000-$00BFFFFFɂ1MBPʂŃC̗LmFAC݂͈͂\
;	菇
;		ʂ̃y[W珇Ƀ[hĂ݂ăoXG[oȂƂmF
;----------------------------------------------------------------
;<d5.l:_SYS_STAT(0)̌
;	bit0`7		MPU̎(0=MC68000,3=68030,4=68040,6=68060)
;	bit14		MMU̗L(0=Ȃ,1=)
;	bit15		FPU/FPCP̗L(0=Ȃ,1=)
;	bit16`31	g(MHz)*10
;<a6.l:obt@
;?d0-d1/a0-a3/a5
iplMessageMemory:
	move.w	sr,-(sp)		;srۑ
	ori.w	#$0700,sr		;荞݋֎~
	move.l	$0008.w,-(sp)		;oXG[xN^ۑ
	movea.l	sp,a5			;spۑ
	move.l	#2f,$0008.w		;oXG[Ń[vI
	suba.l	a2,a2			;a2=$00000000
	move.l	a2,d0			;JnAhX
1:	tst.b	(a2)			;eXg
	adda.l	#$00100000,a2		;̃y[W
	cmpa.l	#$00C00000,a2		;C̖
	blo	1b
2:	movea.l	a5,sp			;sp
	move.l	(sp)+,$0008.w		;oXG[xN^
	move.w	(sp)+,sr		;sr(荞݋x)
	move.l	a2,d1			;IAhX(܂܂Ȃ)
	movea.l	a6,a0			;obt@
	lea.l	100f(pc),a1		;'Motherboard Memory: $'
	bsr	strCopy
	bsr	strMemory		;͈̔͂Ɨeʂ̕
	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
	rts

;		           111111111122222222223333333333
;		 0123456789012345678901234567890123456789
100:	.dc.b	'               Motherboard Memory : $',0
	.even

;----------------------------------------------------------------
;g͈̔͂Ɨeʂ\
;	$01000000-$FFFFFFFFɂ16MBPʂœƗg̗LmFAg݂͈͂\
;	菇
;		ey[W̓ItZbgɏʂ̃y[W珇ɈقȂf[^
;		ʂ̃y[Wɏ񂾂Ƃŏʂ̃y[W̃f[^ωꍇ͏ʂ̃y[W݂͑ȂƔf
;		$2000-$21FF[NƂĎgp
;	
;		MC68000/MC68010/MC68EC020̓AhXoX24bitȂ̂łŕ\g݂͑Ȃ
;<a6.l:obt@
;?d0-d1/a0-a3/a5
iplMessageExmemory:
	move.w	sr,-(sp)		;srۑ
	ori.w	#$0700,sr		;荞݋֎~
	move.l	$0008.w,-(sp)		;oXG[xN^ۑ
	movea.l	sp,a5			;spۑ
;----------------------------------------------------------------
;	page=$FF..$00ɂ
;		[$2100+page].b=[page<<24].b	ۑ
;		oXG[łȂ
;			[page<<24].b=page	eXgf[^
;----------------------------------------------------------------
	move.l	#2f,$0008.w		;oXG[ŃXLbv
	suba.l	a2,a2			;a2=$FF000000,$FE000000,c,$00000000
	lea.l	$2200.w,a1		;a1=$000021FF,$000021FE,c,$00002100
	move.w	#$00FF,d1		;d1=$00FF,$00FE,c,$0000=page
1:	suba.l	#$01000000,a2
	subq.l	#1,a1			;oXG[łƍ̂-(a1)͎gȂ
	move.b	(a2),(a1)		;ۑ
	move.b	d1,(a2)			;eXgf[^
2:	movea.l	a5,sp			;sp
	dbra	d1,1b
;----------------------------------------------------------------
;	page=$FF..$00ɂ
;		[$2000+page].b=~page	;eXgf[^ƈقȂ_~[f[^BoXG[ŏ߂ȂƂɎQƂ
;		[$2000+page].b=[page<<24].b	eXgf[^ǂݏo
;----------------------------------------------------------------
	move.l	#2f,$0008.w		;oXG[ŃXLbv
	suba.l	a2,a2			;a2=$FF000000,$FE000000,c,$00000000
	lea.l	$2100.w,a1		;a1=$000020FF,$000020FE,c,$00002000
	move.w	#$00FF,d1		;d1=$00FF,$00FE,c,$0000=page
	move.b	d1,d0			;d0=$00,$01,c,$FF=~page
1:	addq.b	#1,d0
	suba.l	#$01000000,a2
	move.b	d0,-(a1)		;eXgf[^ƈقȂ_~[f[^BoXG[ŏ߂ȂƂɎQƂ
	move.b	(a2),(a1)		;eXgf[^ǂݏo
2:	movea.l	a5,sp			;sp
	dbra	d1,1b
;----------------------------------------------------------------
;	page=$FF..$00ɂ
;		([$2000+page].b-=page)==0Ȃ
;			[page<<24].b=[$2100+].b	
;----------------------------------------------------------------
	move.l	#2f,$0008.w		;oXG[ŃXLbv
	suba.l	a2,a2			;a2=$FF000000,$FE000000,c,$00000000
	lea.l	$2100.w,a1		;a1=$000020FF,$000020FE,c,$00002000
	move.w	#$00FF,d1		;d1=$00FF,$00FE,c,$0000=page
1:	suba.l	#$01000000,a2
	sub.b	d1,-(a1)		;rBvƂ0
	bne	2f
	move.b	$2200-$2100(a1),(a2)	;
2:	movea.l	a5,sp			;sp
	dbra	d1,1b
;----------------------------------------------------------------
	move.l	(sp)+,$0008.w		;oXG[xN^
	move.w	(sp)+,sr		;sr(荞݋x)
;----------------------------------------------------------------
;	page=$01..$FFɂ
;		[$2000+page].b==0ł͈͂\
;----------------------------------------------------------------
	suba.l	a2,a2			;g̊JnʒuB0=page-1Ɋg͂Ȃ
	lea.l	$2001.w,a3		;a3=$00002001,$00002002,c,$000020FF=$2000+page
1:	tst.b	(a3)
	bne	2f			;pageɊg͂Ȃ
;pageɊg
	move.l	a2,d0			;g̊Jnʒu
	bne	3f			;page-1ɂg
;page-1ɂ͊g͂Ȃ
;pagegn܂
	movea.l	a3,a2			;g̊Jnʒu
	bra	3f

;pageɊg͂Ȃ
2:	move.l	a2,d0			;g̊Jnʒu
	beq	3f			;page-1ɂg͂Ȃ
;page-1ɂ͊g
;pageŊgI
	movea.l	a6,a0			;obt@
	bsr	strExmemory		;g͈̔͂\
	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
	suba.l	a2,a2			;g̊Jnʒu
3:	addq.l	#1,a3
	cmpa.w	#$20FF,a3
	bls	1b
	move.l	a2,d0			;g̊Jnʒu
	beq	4f			;page-1ɂ͊g͂Ȃ
;page-1ɂ͊g
	movea.l	a6,a0			;obt@
	bsr	strExmemory		;͈̔͂Ɨeʂ̕
	movea.l	a6,a1			;obt@
	IOCS	_B_PRINT
4:	rts

;----------------------------------------------------------------
;g͈̔͂Ɨeʂ̕
;<a0.l:obt@
;<a2.l:$2000+pageBg̊Jnʒu
;<a3.l:$2000+pageBg̏Iʒu(܂܂Ȃ)
;?d0-d1/a0-a1
strExmemory:
	move.l	a2,d0
	swap.w	d0
	lsl.l	#8,d0			;JnAhX
	move.l	a3,d1
	swap.w	d1
	lsl.l	#8,d1			;IAhX(܂܂Ȃ)
	lea.l	100f(pc),a1		;'Daughterboard Memory: $'
	bsr	strCopy
;͈̔͂Ɨeʂ̕
;<d0.l:JnAhX
;<d1.l:IAhX(܂܂Ȃ)
;<a0.l:obt@
;?d0/a0-a1
strMemory:
	bsr	strHex8			;JnAhX
	move.b	#'-',(a0)+
	move.b	#'$',(a0)+
	move.l	d0,-(sp)		;JnAhX
	move.l	d1,d0			;IAhX(܂܂Ȃ)
	subq.l	#1,d0			;IAhX(܂)
	bsr	strHex8
	move.b	#' ',(a0)+
	move.b	#'(',(a0)+
	move.l	d1,d0			;IAhX(܂܂Ȃ)
	sub.l	(sp)+,d0		;IAhX(܂܂Ȃ)-JnAhX=e
	swap.w	d0
	lsr.w	#4,d0			;e(16MBP)
	bsr	strDec
	lea.l	101f(pc),a1		;'MB)',13,10
	bsr	strCopy
	rts

;		           111111111122222222223333333333
;		 0123456789012345678901234567890123456789
100:	.dc.b	'             Daughterboard Memory : $',0
101:	.dc.b	'MB)',13,10,0
	.even

;----------------------------------------------------------------
;32bit萮10i̕ɕϊ([TvX)
;<d0.l:32bit萮
;<a0.l:obt@
;>a0.l:̒
strDec:
	movem.l	d0-d2/a1,-(sp)
	tst.l	d0
	bne	1f
	move.b	#'0',(a0)+
	bra	6f

1:	bpl	2f
	move.b	#'-',(a0)+
	neg.l	d0
2:	lea.l	10f(pc),a1
3:	cmp.l	(a1)+,d0		;[TvX
	blo	3b
	subq.l	#4,a1
	bra	5f

4:	addq.b	#1,d1
	sub.l	d2,d0			;10̗ݏ邩
	bhs	4b
	add.l	d2,d0
	move.b	d1,(a0)+
5:	moveq.l	#'0'-1,d1
	move.l	(a1)+,d2
	bne	4b
6:	clr.b	(a0)
	movem.l	(sp)+,d0-d2/a1
	rts

;----------------------------------------------------------------
;32bitȂ10i̕ɕϊ(w,Oaϊ,[TvXȂ)
;<d0.l:32bitȂ
;<d1.l:
;<a0.l:obt@
;>a0.l:̒
strDecN:
	movem.l	d0-d2/a1,-(sp)
	moveq.l	#10,d2
	sub.l	d1,d2			;10-
	bhs	7f
	moveq.l	#0,d2
7:	lsl.w	#2,d2
	lea.l	10f(pc,d2.w),a1
	beq	5b			;10̂Ƃ͖OaϊłȂ
	cmp.l	-4(a1),d0
	blo	5b			;͈͓
	move.l	-4(a1),d0
	subq.l	#1,d0			;ől
	bra	5b

;10̗ݏ̃e[u
10:	.dc.l	1000000000
	.dc.l	100000000
	.dc.l	10000000
	.dc.l	1000000
	.dc.l	100000
	.dc.l	10000
	.dc.l	1000
	.dc.l	100
	.dc.l	10
	.dc.l	1
	.dc.l	0

;----------------------------------------------------------------
;32bitȂ16i8̕ɕϊ
;<d0.l:32bitȂ
;<a0.l:obt@
;>a0.l:̒
strHex8:
	movem.l	d0-d2,-(sp)
	moveq.l	#8-1,d2
1:	rol.l	#4,d0
	moveq.l	#$0F,d1
	and.b	d0,d1
	move.b	10f(pc,d1.w),(a0)+
	dbra	d2,1b
	clr.b	(a0)
	movem.l	(sp)+,d0-d2
	rts

10:	.dc.b	'0123456789ABCDEF'

;----------------------------------------------------------------
;Rs[
;<a0.l:Rs[
;<a1.l:Rs[
;>a0.l:Rs[̖0̈ʒu
;>a1.l:Rs[̖0̒̈ʒu
strCopy:
@@:	move.b	(a1)+,(a0)+
	bne	@b
	subq.l	#1,a0
	rts

	PATCH_END



;----------------------------------------------------------------
;
;	NbN\[`A6WX^̍ŏʃoCgj󂳂
;	https://stdkmd.net/bugsx68k/#rom_clocka6
;
;----------------------------------------------------------------



;----------------------------------------------------------------
;
;	N炷FMhCo듮삷邱Ƃ
;	https://stdkmd.net/bugsx68k/#rom_chime
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF10E0 123C0001               move.b	#$01,d1			;TEST
;		00FF10E4 143C0002               move.b	#$02,d2			;LFO RESET ?1
;		00FF10E8 614E                   bsr.s	$00FF1138		;IOCS _OPMSET
;		00FF10EA 123C0008               move.b	#$08,d1			;KON
;		00FF10EE
;----------------------------------------------------------------

	PATCH_DATA	chime,$00FF10E0,$00FF10EE,$123C0001

	moveq.l	#1,d1			;TEST
	moveq.l	#2,d2			;LFO RESET ?1
	bsr	($00FF1138)PATCH_ZL	;IOCS _OPMSET
;LFO RESET 10ǉ
	moveq.l	#1,d1			;TEST
	moveq.l	#0,d2			;LFO RESET 10
	bsr	($00FF1138)PATCH_ZL	;IOCS _OPMSET
	moveq.l	#8,d1			;KON
;̃R[h璷Ȃ̂ł܂łœ؂

	PATCH_END



;----------------------------------------------------------------
;
;	NbZ[WMemory Managiment Unit̃XyԈĂ
;	https://stdkmd.net/bugsx68k/#rom_mmu
;
;----------------------------------------------------------------



  .if 0
;SASI@̂ƂIOCS _SCSIDRV͉G[Ԃ

;----------------------------------------------------------------
;
;	SASI@̂ƂSCSI _S_RESETsȂ
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF17D6 70F5                   moveq.l	#_SCSIDRV,d0
;		00FF17D8 7200                   moveq.l	#_S_RESET,d1
;		00FF17DA 4E4F                   trap	#15
;		00FF17DC
;----------------------------------------------------------------

	PATCH_DATA	init_sasi_scsi,$00FF17D6,$00FF17DC,$70F57200

	jsr	init_sasi_scsi

	PATCH_TEXT

init_sasi_scsi:
	cmpi.b	#$FF,$00E9602D		;$FF=SASI@,̑=SCSI@
	beq	@f
	SCSI	_S_RESET
@@:	rts

	PATCH_END

  .endif



;----------------------------------------------------------------
;
;	dgƎs̃vO듮삷邱Ƃ
;	https://stdkmd.net/bugsx68k/#rom_dentakud3
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF3BFC 48E76000               movem.l	d1-d2,-(sp)
;		00FF3C00
;----------------------------------------------------------------

	PATCH_DATA	dentakuD3_1st,$00FF3BFC,$00FF3C00,$48E76000

	movem.l	d1-d3,-(sp)

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF3C16 4CDF0006               movem.l	(sp)+,d1-d2
;		00FF3C1A
;----------------------------------------------------------------

	PATCH_DATA	dentakuD3_2nd,$00FF3C16,$00FF3C1A,$4CDF0006

	movem.l	(sp)+,d1-d3

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF3C1C 4CDF0006               movem.l	(sp)+,d1-d2
;		00FF3C20
;----------------------------------------------------------------

	PATCH_DATA	dentakuD3_3rd,$00FF3C1C,$00FF3C20,$4CDF0006

	movem.l	(sp)+,d1-d3

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF3C5A 48E76000               movem.l	d1-d2,-(sp)
;		00FF3C5E
;----------------------------------------------------------------

	PATCH_DATA	dentakuD3_4th,$00FF3C5A,$00FF3C5E,$48E76000

	movem.l	d1-d3,-(sp)

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF3C76 4CDF0006               movem.l	(sp)+,d1-d2
;		00FF3C7A
;----------------------------------------------------------------

	PATCH_DATA	dentakuD3_5th,$00FF3C76,$00FF3C7A,$4CDF0006

	movem.l	(sp)+,d1-d3

	PATCH_END



;----------------------------------------------------------------
;
;	J[\ʂ̍ŉsɂƓd삪ʊOɕ\
;	https://stdkmd.net/bugsx68k/#rom_dentaku64
;
;	d̕\ʒu߂鏈YW𒲐R[hǉ
;	OɂdOFF[`l߂ĂłԂYW𒲐R[hłĂяo
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF4444 3F00                   move.w	d0,-(sp)
;		00FF4446 3F3C0010               move.w	#$0010,-(sp)
;		00FF444A 3F3C00B8               move.w	#$00B8,-(sp)
;		00FF444E 3F380BFE               move.w	$0BFE.w,-(sp)		;[$0BFE.w].w:d\YhbgW
;		00FF4452 3F380BFC               move.w	$0BFC.w,-(sp)		;[$0BFC.w].w:d\XhbgW
;		00FF4456 3F3C0002               move.w	#$0002,-(sp)
;		00FF445A 61002368               bsr.w	$00FF67C4		;_TXFILLs
;		00FF445E 4FEF000C               lea.l	$000C(sp),sp
;		00FF4462 4267                   clr.w	-(sp)
;		00FF4464 3F3C0010               move.w	#$0010,-(sp)
;		00FF4468 3F3C00B8               move.w	#$00B8,-(sp)
;		00FF446C 3F380BFE               move.w	$0BFE.w,-(sp)		;[$0BFE.w].w:d\YhbgW
;		00FF4470 3F380BFC               move.w	$0BFC.w,-(sp)		;[$0BFC.w].w:d\XhbgW
;		00FF4474 3F3C0003               move.w	#$0003,-(sp)
;		00FF4478 6100234A               bsr.w	$00FF67C4		;_TXFILLs
;		00FF447C 4FEF000C               lea.l	$000C(sp),sp
;		00FF4480 301F                   move.w	(sp)+,d0
;		00FF4482 6704                   beq.s	$00FF4488
;		00FF4484 610065D6               bsr.w	$00FFAA5C		;IOCS _MS_CURON
;		00FF4488 4CDF7FFE               movem.l	(sp)+,d1-d7/a0-a6
;		00FF448C 4E75                   rts
;
;		00FF448E
;----------------------------------------------------------------

	PATCH_DATA	dentaku64_1st,$00FF4444,$00FF448E,$3F003F3C

;dOFF
	move.w	d0,-(sp)
	move.l	#184<<16|16,-(sp)
	move.l	$0BFC.w,-(sp)		;[$0BFE.w].w:d\YhbgW
					;[$0BFC.w].w:d\XhbgW
	move.w	#2,-(sp)
	bsr	($00FF67C4)PATCH_ZL	;_TXFILLs
	clr.w	10(sp)
	addq.w	#1,(sp)			;3
	bsr	($00FF67C4)PATCH_ZL	;_TXFILLs
	lea.l	12(sp),sp
	move.w	(sp)+,d0
	beq	@f
	bsr	($00FFAA5C)PATCH_ZL	;IOCS _MS_CURON
@@:	movem.l	(sp)+,d1-d7/a0-a6
	rts

dentaku64:
	addq.w	#1,d1			;d̃eLXgYW
	cmp.w	#31,d1			;J[\̎̍sYW31ȉ̂Ƃ̓J[\̎̍s
	bls	@f
	cmp.w	$0972.w,d1		;[$0972.w].w:eLXg̍s-1
	bls	@f			;J[\̎̍sR\[͈͓̔̂Ƃ̓J[\̎̍s
	move.w	$0972.w,d1		;[$0972.w].w:eLXg̍s-1
	beq	@f			;R\[1sȂƂ̓R\[̍ŉs
	subq.w	#1,d1			;ȊO̓R\[̉2Ԗڂ̍s
@@:	rts

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF44A6 5241                   addq.w	#1,d1			;d̃eLXgYW
;		00FF44A8 E941                   asl.w	#4,d1
;----------------------------------------------------------------

	PATCH_DATA	dentaku64_2nd,$00FF44A6,$00FF44A8,$5241E941

	PATCH_bsr	dentaku64_1st,dentaku64

	PATCH_END



;----------------------------------------------------------------
;
;	\tgL[{[h́L[̑ܕĂȂ
;	https://stdkmd.net/bugsx68k/#rom_softkeyboard
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF5AA8 2B80                   .dc.b	__M_M_MM,M_______
;		00FF5AAA 0A00                   .dc.b	____M_M_,________
;----------------------------------------------------------------

	PATCH_DATA	softkeyboard,$00FF5AA8,$00FF5AAA,$2B800A00

	.dc.b	__MMM_MM,M_______

	PATCH_END



;----------------------------------------------------------------
;
;	_DEFCHRŃtHgTCY0w肳ꂽƂ8ɓǂݑւ鏈R[h0̂Ƃ@\ĂȂ
;	_DEFCHRŃtHgTCY6włȂ
;	_DEFCHR_FNTADRtHgp^[$0C46.wɍ쐬ĕԂƂɏ㏑ĂۑȂ̂ɃG[ɂȂȂ
;	_DEFCHRŃtHgAhXX68030̃nC060turbõ[JwĂROMƌFăG[ɂȂ
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF6ADA 70FF                   moveq.l	#$FF,d0
;		00FF6ADC 48E76040               movem.l	d1-d2/a1,-(sp)
;		00FF6AE0 2401                   move.l	d1,d2
;		00FF6AE2 4842                   swap.w	d2
;		00FF6AE4 6604                   bne.s	$00FF6AEA
;		00FF6AE6 343C0008               move.w	#$0008,d2
;		00FF6AEA B47C0006               cmp.w	#$0006,d2
;		00FF6AEE 6722                   beq.s	$00FF6B12
;		00FF6AF0 20780458               movea.l	$0458.w,a0		;[$0458.w].l:[$0116]_FNTADR
;		00FF6AF4 4E90                   jsr	(a0)
;		00FF6AF6 2040                   movea.l	d0,a0
;		00FF6AF8 70FF                   moveq.l	#$FF,d0
;		00FF6AFA B1FC00F00000           cmpa.l	#$00F00000,a0		;ROMȂLZ
;		00FF6B00 6410                   bcc.s	$00FF6B12
;		00FF6B02 5242                   addq.w	#1,d2
;		00FF6B04 5241                   addq.w	#1,d1
;		00FF6B06 C4C1                   mulu.w	d1,d2
;		00FF6B08 5342                   subq.w	#1,d2
;		00FF6B0A 10D9                   move.b	(a1)+,(a0)+
;		00FF6B0C 51CAFFFC               dbra.w	d2,$00FF6B0A
;		00FF6B10 4280                   clr.l	d0
;		00FF6B12 4CDF0206               movem.l	(sp)+,d1-d2/a1
;		00FF6B16 4E75                   rts
;
;		00FF6B18
;----------------------------------------------------------------

	PATCH_DATA	defchr,$00FF6ADA,$00FF6B18,$70FF48E7

	movem.l	d1-d2/a1,-(sp)
	move.l	d1,d2
	swap.w	d2
	movea.l	$0458.w,a0		;[$0458.w].l:[$0116]_FNTADR
	jsr	(a0)
;<d0.l:tHgAhX
;<d1.w:̃oCg-1
;<d2.w:c̃hbg-1
	movea.l	d0,a0			;tHgAhX
	cmpa.w	#$0C46.w,a0		;[$0C46.w].b[72]:_FNTADR̃tHg쐬obt@
	beq	4f			;tHgp^[$0C46.wɍ쐬ꂽBROMł͂Ȃɏ㏑ĂۑȂ̂Ŏs
	swap.w	d0
	cmp.w	#$00F0,d0
	blo	1f			;tHgAhXROMwĂȂ
	cmp.w	#$0100,d0
	blo	4f			;tHgAhXROMwĂB㏑łȂ̂Ŏs
;tHgAhXROMwĂȂ
;tHgp^[Rs[
1:	move.w	d1,d0			;(d1+1)*(d2+1)-1=d1*d2+d1+d2
	mulu.w	d2,d0
	add.w	d1,d0
	add.w	d2,d0
2:	move.b	(a1)+,(a0)+
	dbra	d0,2b
	moveq.l	#0,d0
3:	movem.l	(sp)+,d1-d2/a1
	rts

4:	moveq.l	#-1,d0
	bra	3b

	PATCH_END



;----------------------------------------------------------------
;
;	_CRTMOD
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF6B8C 41F900E80028           lea.l	$00E80028,a0
;		00FF6B92
;----------------------------------------------------------------

	PATCH_DATA	crtmod,$00FF6B8C,$00FF6B92,$41F900E8

	jmp	crtmod

	PATCH_TEXT

;----------------------------------------------------------------
;IOCSR[$10 _CRTMOD
;	ʃ[h̎擾Ɛݒ
;<d1.w:ݒ̉ʃ[hB$FFFF=擾̂,$00xx=,$01xx=Ȃ,$43xx=CRT,$4Cxx=LCD
;>d0.l:ݒỎʃ[h
;
;	ʃ[h	𑜓x	ʃTCY	ʃTCY	F	y[W
;	0			512x512		1024x1024	16	1
;	1			512x512		1024x1024	16	1
;	2			256x256		1024x1024	16	1
;	3			256x256		1024x1024	16	1
;	4			512x512		512x512		16	4
;	5			512x512		512x512		16	4
;	6			256x256		512x512		16	4
;	7			256x256		512x512		16	4
;	8			512x512		512x512		256	2
;	9			512x512		512x512		256	2
;	10			256x256		512x512		256	2
;	11			256x256		512x512		256	2
;	12			512x512		512x512		65536	1
;	13			512x512		512x512		65536	1
;	14			256x256		512x512		65536	1
;	15			256x256		512x512		65536	1
;	16			768x512		1024x1024	16	1
;	17			1024x424	1024x1024	16	1
;	18			1024x848	1024x1024	16	1
;	19		VGA	640x480		1024x1024	16	1
;	20			768x512		512x512		256	2
;	21			1024x424	512x512		256	2
;	22			1024x848	512x512		256	2
;	23		VGA	640x480		512x512		256	2
;	24			768x512		512x512		65536	1
;	25			1024x424	512x512		65536	1
;	26			1024x848	512x512		65536	1
;	27		VGA	640x480		512x512		65536	1
;
;	CRTLCD
;		eʃ[h̓gꂼCRTLCDɕ
;		$00ED0095bit00̂ƂCRTA1̂ƂLCD̓gŏo͂
;
;	ʃ[h17
;		24.7kHzA53.1HzA1024x424A1024x1024A16FBX68000ォ炠邪J
;		LCD̂Ƃ͉ʃ[h16̏㉺
;
;	ʃ[h18
;		24.7kHzA53.1HzA1024x848(C^[[X)A1024x1024A16FBX68000ォ炠邪J
;		LCD̂Ƃ͉ʃ[h16̏㉺ăC^[[Xɂ
;
;	ʃ[h19(VGA[h)
;		31.5kHzA60HzA640x480A1024x1024A16FBX68000 CompactŒǉꂽ
;		CRT̂Ƃ͉ʃ[h16̎͂
;		LCD̂Ƃ͂̂܂
;
;	ʃ[h20`23
;		ʃ[h16`19512x512A256FɕύX́BX68030ŒǉꂽBJ
;
;	ʃ[h24`27
;		ʃ[h16`19512x512A65536FɕύX́BX68030ŒǉꂽBJ
;
;	OtBbNpbg̃oO(ROM 1.0`1.3)
;		_CRTMODw肳ꂽʃ[hƈقȂFŃOtBbNpbg
;		256x25616FA512x512256FAȊO65536FɂȂ
;		C
;
;	ʃ[h20`27̃oO(ROM 1.3)
;		_CRTMODŉʃ[h20`27w肷IOCS̃[NGẢʃ[h̔ԍ16`19ɂȂ
;		܂A_G_CLR_ONʃ[h20`27ɑΉĂȂ
;		_CRTMOD͉ʃ[h20`27w肳ƈU16`19ɂĂFύX
;		̂Ƃʃ[h̔ԍύX16`19̂܂ܕuĂ
;		A_G_CLR_ON͉ʃ[h16`19̂Ƃ16Fŏ
;		Ȃ킿A_CRTMOD20`27w肵256F܂65536FɂĂA
;		\邽߂_G_CLR_ONĂяo16F16`19ƓɂȂĂ܂
;		C
;
;	NbsOGÃoO(ROM 1.3)
;		_CRTMODŉʃ[h22܂26ɂƃNbsOGA512x848ɂȂ
;		C
;
;	VGAIV[^̖
;		`XVIɂVGAIV[^Ȃ̂VGA[hgŏo͂Ȃ
;		VGAIV[^ꍇ
;			(50.350MHz/2)/(8*100)=31.469kHz
;			(50.350MHz/2)/(8*100*525)=59.94Hz
;		VGAIV[^Ȃꍇ
;			(69.5519MHz/3)/(8*100)=28.98kHz
;			(69.5519MHz/3)/(8*100*525)=55.2Hz
;		傫O킯ł͂Ȃ̂Ń}`XLj^͒Ǐ]ł邪AĈŏC
;
;	VGAIV[^̗L̔
;		VGA[h̐Ԃ́AVGAIV[^Ƃ16.683msAȂƂ18.116ms
;		荞݂̊ԂTimer-C110ms7.5msi񂾂ǂVGAIV[^̗L𔻕ʂł͂
;		ŎH
;
;----------------------------------------------------------------

;ʃ[h
crtmod_modes	equ	28	;ʃ[h̐

	.offset	0
crtmod_param_1_width:	.ds.w	1
crtmod_param_1_height:	.ds.w	1
crtmod_param_1_offset:	.ds.w	1
crtmod_param_1_r20h:	.ds.b	1
			.ds.b	1
crtmod_param_1_size:
	.text

	.offset	0
crtmod_param_2_r00:	.ds.w	1
crtmod_param_2_r01:	.ds.w	1
crtmod_param_2_r02:	.ds.w	1
crtmod_param_2_r03:	.ds.w	1
crtmod_param_2_r04:	.ds.w	1
crtmod_param_2_r05:	.ds.w	1
crtmod_param_2_r06:	.ds.w	1
crtmod_param_2_r07:	.ds.w	1
			.ds.b	1
crtmod_param_2_r20l:	.ds.b	1
crtmod_param_2_hrl:	.ds.b	1
crtmod_param_2_r08:	.ds.b	1
crtmod_param_2_size:
	.text

crtmod_param_1	.macro	width,height,number2nd,r20h
	.dc.w	width
	.dc.w	height
	.dc.w	crtmod_param_2_size*number2nd
	.dc.b	r20h			;R20H
	.dc.b	0
	.endm

crtmod_param_2	.macro	ht,hs,hb,hd,hf,vt,vs,vb,vd,vf,r20l,hrl,r08
	.fail	(ht.and.1)!=0
	.fail	ht!=hs+hb+hd+hf
	.fail	vt!=vs+vb+vd+vf
	.dc.w	hs+hb+hd+hf-1		;R00
	.dc.w	hs-1			;R01
	.dc.w	hs+hb-5			;R02
	.dc.w	hs+hb+hd-5		;R03
	.dc.w	vs+vb+vd+vf-1		;R04
	.dc.w	vs-1			;R05
	.dc.w	vs+vb-1			;R06
	.dc.w	vs+vb+vd-1		;R07
	.dc.b	0
	.dc.b	r20l			;R20L
	.dc.b	hrl			;HRL
	.dc.b	r08			;R08
	.endm

	.text
	.even
crtmod:
crtmod_regs	reg	d1/d2/d3/d7/a0/a1/a4/a5/a6
	movem.l	crtmod_regs,-(sp)

	lea.l	$00E88000,a6
o	reg	-$00E88000(a6)

;p[^
;<d1.w:ݒ̉ʃ[hB$FFFF=擾̂,$00xx=,$01xx=Ȃ,$43xx=CRT,$4Cxx=LCD
	moveq.l	#0,d7
	move.b	$093C.w,d7		;ݒỎʃ[h
	swap.w	d7
;<d7.l:ݒỎʃ[h<<16
	cmp.w	#$FFFF,d1
	beq	crtmod_end		;擾̂݁BI
	move.w	d1,d7
	clr.b	d7
;<d7.w:d1.w&$FF00
	cmp.w	#$4300,d7		;CRT
	beq	1f
	cmp.w	#$4C00,d7		;LCD
	bne	2f
;CRT܂LCD
;<d7.w:$4300=CRT,$4C00=LCD
1:	____SRAM_WRITABLE____
	cmp.w	#$4C00,d7
	bseq.b	#CRT_LCD_SWITCH,EXTENSION_SWITCH	;gXCb`
	____SRAM_READONLY____
	clr.w	d7			;
2:
;<d7.w:d1.w&$FF00B$0000=,$0100=Ȃ
	bsr	crtmod_get_param_1	;p[^1̃AhX߂
;<a4.l:p[^1
	lea.l	crtmod_table_2(pc),a5
	adda.w	crtmod_param_1_offset(a4),a5
;<a5.l:p[^2
	moveq.l	#7,d3
	and.b	crtmod_param_1_r20h(a4),d3	;[h0`7
;<d3.w:[h0`7

  .if 0
;󔒊Ԃ҂
;	CRTCĂȂ̂ŐfԂɂȂȂ
@@:	btst.b	#4,($00E88001)o		;0=󔒊,1=f
	beq	@b
@@:	btst.b	#4,($00E88001)o		;0=󔒊,1=f
	bne	@b
  .endif

;\OFF
	move.w	#$0000,($00E82600)o	;REG3 XvCgOFF,eLXgOFF,OtBbNOFF

	tst.w	d7
	bne	crtmod_not_init_1	;Ȃ
;

;CRTC |[g
	move.w	#$0000,($00E80480)o	;[$00E80480].w:CRTC |[g(X^Rs[|-|NA|摜)

;eLXgJ[\OFF
	IOCS	_B_CUROFF

;eLXgVRAM
;	X^Rs[gƑR[hȂ
;	CRTCĂȂ̂ŃX^Rs[IȂ
	bset.b	#3,($00E80028)o		;MPUD
	move.w	#$0133,($00E8002A)o	;ANZXJnBv[0,1
	moveq.l	#0,d1
	moveq.l	#0,d2
	lea.l	$00E00000,a0		;eLXgVRAM
	move.w	#(1024/8*1024)/(4*2)-1,d0	;16384
@@:	move.l	d1,(a0)+
	move.l	d2,(a0)+
	dbra	d0,@b
	move.w	#$0033,($00E8002A)o	;ANZXI
	bclr.b	#3,($00E80028)o		;CRTCD

crtmod_not_init_1:

;CRTC R00`R07,R20,HRL
	move.w	d3,d2			;[hBR20H
	lsl.w	#8,d2			;R20H<<8
	move.b	crtmod_param_2_r20l(a5),d2	;(R20H<<8)+(R20L)
;<d2.w:R20=(R20H<<8)+(R20L)
	moveq.l	#%00011111,d0
	and.b	($00E80028+1)o,d0	;R20LB̉𑜓x
	cmp.w	#%00010111,d0
	bne	@f
	moveq.l	#%00000110,d0		;$17$06ɓǂݑւ
@@:
	moveq.l	#%00011111,d1
	and.b	d2,d1			;R20LBV𑜓x
	cmp.w	#%00010111,d1
	bne	@f
	moveq.l	#%00000110,d1		;$17$06ɓǂݑւ
@@:
	ror.w	#4,d0			;...........432103210...........4
	ror.w	#4,d1
	cmp.w	d0,d1
	bcc	1f			;𑜓xȂ
;𑜓xႭȂ
;<d2.w:R20=(R20H<<8)+(R20L)
	move.w	d2,($00E80028)o		;R20
	tst.b	crtmod_param_2_hrl(a5)
	bsne.b	#1,($00E8E007)o		;HRL
	lea.l	($00E80002)o,a0		;R01
	lea.l	crtmod_param_2_r01(a5),a1
	move.w	(a1)+,(a0)+		;R01
	move.l	(a1)+,(a0)+		;R02,R03
	move.l	(a1)+,(a0)+		;R04,R05
	move.l	(a1)+,(a0)+		;R06,R07
	move.w	crtmod_param_2_r00(a5),($00E80000)o	;R00
	bra	2f

;𑜓xȂ
;<d2.w:R20=(R20H<<8)+(R20L)
1:	lea.l	($00E80000)o,a0		;R00
	lea.l	crtmod_param_2_r00(a5),a1
	move.l	(a1)+,(a0)+		;R00,R01
	move.l	(a1)+,(a0)+		;R02,R03
	move.l	(a1)+,(a0)+		;R04,R05
	move.l	(a1)+,(a0)+		;R06,R07
	move.w	d2,($00E80028)o		;R20
	tst.b	crtmod_param_2_hrl(a5)
	bsne.b	#1,($00E8E007)o		;HRL
2:

;CRTC R08
;	OAWXg
;	X[p[C|[YƂrfỈfX68000̉fd˂邽߂ɁA
;	rfIX68000̐AԂ̐擪̎ԍ38.863632MHz̃TCNŎw肷
;	𑜓x512x512̂Ƃ
;		pX4LN^BR01=4-1=3
;		obN|[`6LN^BR02=4+6-5=5
;		OAWXg44
;		perl -e "print((4.7+4.7)*38.863632-(4*8*(4+6))-1)"
;		44.3181408
;	𑜓x256x256̂ƂB1hbgǉ
;		pX2LN^BR01=2-1=1
;		obN|[`3LN^BR02=2+3-5=0
;		OAWXg36
;		perl -e "print((4.7+4.7)*38.863632-(8*(8*(2+3)+1))-1)"
;		36.3181408
	moveq.l	#0,d0
	move.b	crtmod_param_2_r08(a5),d0
	move.w	d0,($00E80010)o		;R08

;CRTC R09`R19,R21`R24
	moveq.l	#0,d0
	lea.l	($00E80012)o,a0
	move.w	d0,(a0)+		;R09
	move.l	d0,(a0)+		;R10,R11
	move.l	d0,(a0)+		;R12,R13
	move.l	d0,(a0)+		;R14,R15
	move.l	d0,(a0)+		;R16,R17
	move.l	d0,(a0)+		;R18,R19
	addq.l	#2,a0
	move.w	#$0033,(a0)+		;R21
	move.l	d0,(a0)+		;R22,R23
	move.w	d0,(a0)+		;R24

;XvCgRg[
	lea.l	$00EB0000,a0
;<a0.l:$00EB0000
;Rg[
;		  SP     BG1  BG0
	move.w	#%0_000_01_0_00_0,$00EB0808-$00EB0000(a0)	;Rg[BSPOFF,BG1=TEXT1,BG1OFF,BG0=TEXT0,BG0OFF
;XvCgCRTC R20̉5rbg%1_??_1?̂Ƃ
	moveq.l	#%1_00_10,d0
	and.b	crtmod_param_2_r20l(a5),d0	;CRTC R20L
	cmp.w	#%1_00_10,d0
	beq	crtmod_no_sprite	;XvCg
;XvCgL
;<a0.l:$00EB0000
;𑜓x
;	ʏCRTC R20LƓlݒ肷邪ACRTC R20L=%1_00_01,HRL=1̂Ƃ%1_00_00ɕύX
	moveq.l	#%1_11_11,d1
	and.b	crtmod_param_2_r20l(a5),d1	;CRTC R20L
	cmp.b	#%1_00_01,d1		;512x256
	bne	@f
	tst.b	crtmod_param_2_hrl(a5)
	beq	@f
	subq.b	#%1_00_01-%1_00_00,d1	;256x256
@@:
;<d1.w:𑜓x
;\Jnʒu
	moveq.l	#4,d0
	add.w	crtmod_param_2_r02(a5),d0
	move.w	d0,$00EB080C-$00EB0000(a0)	;\JnʒuBCRTC R02+4
;g[^
;	\Jnʒuݒ130us҂Ă琅g[^ݒ肷
;	g[^͐256hbĝƂCRTC R00ƓlAȊO255
;		Inside X68000ɒ𑜓x256x256̂ƂCRTC R00ƓlAȊO255ݒ肷ƏĂ邪A
;		𑜓x256x256̂Ƃ255ƃXvCgꍇ
;		512hbĝƂ255ɂĂ܂ƁA256hbg琅512hbgɐ؂ւƂɃXvCg̐̈ʒu邱Ƃ
;	ROM 1.3500us҂Ă邪Adbra68030 25MHzɍ킹Ă̂060turbôƂEGCgs
;<d1.w:𑜓x
	moveq.l	#500/50,d0		;500us
	bsr	wait50us		;50usPʂ̃EFCg
	moveq.l	#%0_00_11,d0
	and.b	d1,d0
	bne	1f			;256hbgȊO
;256hbg
	move.w	crtmod_param_2_r00(a5),$00EB080A-$00EB0000(a0)	;g[^BCRTC R00
	bra	2f

;256hbgȊO
1:	move.w	#255,$00EB080A-$00EB0000(a0)	;g[^B255
2:
;\Jnʒu
	move.w	crtmod_param_2_r06(a5),$00EB080E-$00EB0000(a0)	;\JnʒuBCRTC R06
;𑜓x
;<d1.w:𑜓x
	move.w	d1,$00EB0810-$00EB0000(a0)	;𑜓x
	bra	crtmod_sprite_end

;XvCg
;<a0.l:$00EB0000
crtmod_no_sprite:
	move.w	#255,d1
	move.w	d1,$00EB080C-$00EB0000(a0)	;\Jnʒu
	moveq.l	#500/50,d0		;500us
	bsr	wait50us		;50usPʂ̃EFCg
	move.w	d1,$00EB080A-$00EB0000(a0)	;g[^
	move.w	d1,$00EB080E-$00EB0000(a0)	;\Jnʒu
	move.w	d1,$00EB0810-$00EB0000(a0)	;𑜓x
crtmod_sprite_end:

;R\[
	move.l	#$00E00000,$0944.w	;[$0944.w].l:eLXg\v[擪AhX
	clr.l	$0948.w			;[$0948.w].l:eLXg\JnAhXItZbg
	move.w	crtmod_param_1_width(a4),d0	;
	move.w	crtmod_param_1_height(a4),d1	;
	lsr.w	#3,d0			;/8
	lsr.w	#4,d1			;/16
	subq.w	#1,d0			;/8-1
	subq.w	#1,d1			;/16-1B42416Ŋ؂ȂƂɒ
	move.w	d0,$0970.w		;[$0970.w].w:eLXǧ-1
	move.w	d1,$0972.w		;[$0972.w].w:eLXg̍s-1

;eLXgJ[\
	clr.l	$0974.w			;[$0974.w].w:eLXgJ[\XW
					;[$0976.w].w:eLXgJ[\YW

;OtBbNʂ̃NbsOGA
	move.w	crtmod_param_1_width(a4),d0	;
	move.w	crtmod_param_1_height(a4),d1	;
	cmp.b	#4,d3
	bcc	3f			;[h4`7B1024x1024܂
;[h0`3B512x512܂
;ʃ[h20`27͕\ʂʂ傫
	move.w	#512,d2
	cmp.w	d2,d0
	bls	1f
	move.w	d2,d0
1:	cmp.w	d2,d1
	bls	2f
	move.w	d2,d1
2:
3:	subq.w	#1,d0			;Xő
	subq.w	#1,d1			;Yő
	clr.l	$0968.w			;[$0968.w].w:OtBbNNbsOGA(Xŏl)
					;[$096A.w].w:OtBbNNbsOGA(Yŏl)
	move.w	d0,$096C.w		;[$096C.w].w:OtBbNNbsOGA(Xől)
	move.w	d1,$096E.w		;[$096E.w].w:OtBbNNbsOGA(Yől)

;}EXJ[\
	clr.l	d1
	move.l	$096C.w,d2		;[$096C.w].w:OtBbNNbsOGA(Xől)
					;[$096E.w].w:OtBbNNbsOGA(Yől)
	IOCS	_MS_LIMIT		;$77 }EXJ[\̈ړ͈͂ݒ肷

;OtBbNVRAMỸItZbg
					;d3=0 1 2 3 4 5 6 7
	moveq.l	#4,d0			;d0=4 4 4 4 4 4 4 4
	and.b	d3,d0			;d0=0 0 0 0 4 4 4 4
	addq.b	#4,d0			;d0=4 4 4 4 8 8 8 8
	lsl.w	#8,d0			;d0=1024 1024 1024 1024 2048 2048 2048 2048
	move.l	d0,$0960.w		;[$0960.w].l:OtBbNVRAMỸItZbg

;OtBbNʂ̐F-1
	clr.w	$0964.w			;[$0964.w].w:OtBbNʂ̐F-1(0=OtBbNʎgps)

;OtBbNʂ̃y[W
;<d3.w:[h0`7
					;d3=0 1 2  3  4  5  6  7
	moveq.l	#4,d0			;d0=4 4 4  4  4  4  4  4
	lsr.b	d3,d0			;d0=4 2 1  0  0  0  0  0
	seq.b	d1			;d1=0 0 0 -1 -1 -1 -1 -1
	sub.b	d1,d0			;d0=4 2 1  1  1  1  1  1
	move.b	d0,$093D.w		;[$093D.w].b:OtBbNʂ̃y[W

	tst.w	d7
	bne	crtmod_not_init_2	;Ȃ
;

;OtBbNpbg
;<d3.w:[h0`7
	bsr	init_gpalet		;OtBbNpbg
;?d0/d1/d2/a0/a1

;eLXgpbg
	lea.l	$00ED002E,a0		;[$00ED002E].w:eLXgpbg̃VXel
	lea.l	($00E82200)o,a1		;[$00E82200].w[16]:VCN eLXgpbg(16F)
	move.l	(a0)+,(a1)+		;0,1
	move.l	(a0)+,(a1)+		;2,3
	move.l	(a0),d0			;d0=4|8
	move.w	d0,d1			;d1=?|8
	swap.w	d0			;d0=8|4
	move.w	d0,(a1)+		;4
	move.w	d0,(a1)+		;5
	move.w	d0,(a1)+		;6
	move.w	d0,(a1)+		;7
	move.w	d1,d0			;d0=8|8
	move.l	d0,(a1)+		;8,9
	move.l	d0,(a1)+		;10,11
	move.l	d0,(a1)+		;12,13
	move.l	d0,(a1)+		;14,15

;RgXg
	move.b	$00ED0028,($00E8E001)o	;[$00ED0028].b:RgXg̃VXel
					;[$00E8E001].b:SYS RgXg(0..15)

;rfIRg[
	move.w	#%00_00_01_10_11_10_01_00,($00E82500)o	;REG2 XvCg>eLXg>OtBbN

;eLXgJ[\ON
	IOCS	_B_CURON

crtmod_not_init_2:

;\ON
	move.w	#$0020,($00E82600)o	;REG3 XvCgOFF,eLXgON,OtBbNOFF

;I
;<d7.l:ݒỎʃ[h<<16
crtmod_end:
	clr.w	d7
	swap.w	d7			;ݒỎʃ[h
	move.l	d7,d0
	movem.l	(sp)+,crtmod_regs
	rts

;----------------------------------------------------------------
;p[^1̃AhX߂
;<d1.b:ʃ[hB͈͊ÔƂ͋N̉ʃ[hB[$093C.w].bɏ܂
;>a4.l:p[^1
;?d1.w
	.text
	.even
crtmod_get_param_1:
	and.w	#$00FF,d1
	cmp.w	#crtmod_modes,d1
	blo	@f
	move.b	$00ED001D,d1		;[$00ED001D].b:N̉ʃ[h
@@:	move.b	d1,$093C.w		;ݒ̉ʃ[h
	btst.b	#CRT_LCD_SWITCH,EXTENSION_SWITCH	;gXCb`
	beq	@f			;CRT
	add.w	#crtmod_modes,d1	;LCD
@@:	lea.l	crtmod_table_1(pc),a4
  .if crtmod_param_1_size=8
	lsl.w	#3,d1
  .else
	mulu.w	#crtmod_param_1_size,d1
  .endif
	adda.w	d1,a4
	rts

;----------------------------------------------------------------
;50usPʂ̃EFCg
;	ROM̃R[hTimer-C̃JE^gĂ邪AłDBRA̋󃋁[vp
;	$0CBA.w$0CBC.wDBRA̋󃋁[v̉񐔂߂
;	ROM 1.0ɂ$0CB6.wȍ~Ȃ̂ŗ\ߋ߂Ă
;
;	$0CBA.w000̂ƂMHzl*1000/10A030/040/060̂ƂMHzl*1000/6
;	000/030̂ƂDBRA̋󃋁[v1msɉ邩Ă
;	MHzl̂ƂA0400303/2{A0600306{B␳lƂ
;	50us1ms1/20Ȃ̂$0CBA.w65536/20|ďʃ[h50usDBRA̋󃋁[v̉񐔂Ƃ
;
;	$0CBC.w				$0CBA.w
;			MHz	us/	/ms@030	/ms		␳l	␳l*65536/20
;	0	68000	10	1	1000		1000		1	3276.8
;			16.667	0.667	1666.667	1666.667	1	3276.8
;	3	68030	25	0.24	4166.667	4166.667	1	3276.8
;	4	68040	25	0.16	4166.667	6250		1.5	4915.2
;	6	68060	50	0.02	8333.333	25000		6	19660.8
;
;<d0.l:(50usP)
	.text
	.even
wait50us:
	movem.l	d0-d2,-(sp)
	move.w	$0CB8.w,d1
	cmpi.b	#4,$0CBC.w
	blo	2f
	beq	1f
	mulu.w	#19661,d1	;68060
	bra	3f

1:	mulu.w	#4915,d1	;68040
	bra	3f

2:	mulu.w	#3277,d1	;68000/68030
3:	swap.w	d1		;/50us
	move.w	d1,d2
	bra	7f

4:	swap.w	d0
5:	move.w	d2,d1
6:
	dbra	d1,6b
7:	dbra	d0,5b
	swap.w	d0
	dbra	d0,4b
	movem.l	(sp)+,d0-d2
	rts

;----------------------------------------------------------------
;ʃ[h
;
;	800x600 SVGA 56Hz
;		36MHz/(8*128)=35.15625kHz
;		36MHz/(8*128*625)=56.25Hz
;		128,9,16,100,3		100/128=0.78125
;		625,2,22,600,1		600/625=0.96
;	LCD 768x512 SVGA 56Hz
;		(69.5519MHz/2)/(8*124)=35.056401kHz	R20L=$16 HRL=0
;		(69.5519MHz/2)/(8*124*625)=56.090242Hz
;		124,9,15,96,4		96/124=0.774196
;		625,2,66,512,45		512/625=0.8192
;	LCD 512x512 SVGA 56Hz
;		(69.5519MHz/3)/(8*82)=35.341413kHz	R20L=$15 HRL=0
;		(69.5519MHz/3)/(8*82*625)=56.546260Hz
;		82,6,10,64,2		64/82=0.780488
;		625,2,66,512,45		512/625=0.8192
;	LCD 256x256 SVGA 56Hz
;		(69.5519MHz/6)/(8*42)=34.499950kHz	R20L=$10 HRL=0	X^2xǂ
;		(69.5519MHz/6)/(8*42*625)=55.199921Hz
;		42,3,5,32,2		32/42=0.761905
;		625,2,66,512,45		512/625=0.8192
;	LCD 768x600 SVGA 56Hz
;		(69.5519MHz/2)/(8*124)=35.056401kHz	R20L=$16 HRL=0
;		(69.5519MHz/2)/(8*124*625)=56.090242Hz
;		124,9,15,96,4		96/124=0.774196
;		625,2,22,600,1		600/625=0.96
;	LCD 768x1024 SVGA 56Hz
;		(69.5519MHz/2)/(8*124)=35.056401kHz	R20L=$1A HRL=0	C^[[X
;		(69.5519MHz/2)/(8*124*625)=56.090242Hz
;		124,9,15,96,4		96/124=0.774196
;		625,2,66,512,45		512/625=0.8192
;
;	800x600 SVGA 75Hz
;		49.5MHz/(8*132)=46.875kHz
;		49.5MHz/(8*132*625)=75Hz
;		132,10,20,100,2		100/132=0.757576
;		625,3,21,600,1		600/625=0.96
;	LCD 512x512 SVGA 75Hz
;		(69.5519MHz/2)/(8*92)=47.249932kHz	R20L=$16 HRL=0	XvCgs(X68030@ŊmFς)
;		(69.5519MHz/2)/(8*92*625)=75.599891Hz
;		92,8,14,64,6		64/92=0.695652
;		625,3,65,512,45		512/625=0.8192
;	LCD 256x256 SVGA 75Hz
;		(69.5519MHz/4)/(8*46)=47.249932kHz	R20L=$11 HRL=1	XvCg̉𑜓x$10
;		(69.5519MHz/4)/(8*46*625)=75.599891Hz
;		46,4,7,32,3		32/46=0.695652
;		625,3,65,512,45		512/625=0.8192
;
;	640x480 VGA 60Hz
;		25.175MHz/(8*100)=31.469kHz
;		25.175MHz/(8*100*525)=59.94Hz
;		100,12,6,80,2		80/100=0.8
;		525,2,33,480,10		480/525=0.9143
;	LCD 640x480 VGA 60Hz
;		(50.350MHz/2)/(8*100)=31.469kHz		R20L=$17 HRL=0	Compact
;		(50.350MHz/2)/(8*100*525)=59.94Hz
;		100,12,6,80,2		80/100=0.8
;		525,2,32,480,11		480/525=0.9143
;		XVI܂ł69.5519MHz3ɂȂ
;		(69.5519MHz/3)/(8*100)=28.980kHz	R20L=$17 HRL=0	XVI܂
;		(69.5519MHz/3)/(8*100*525)=55.20Hz
;
;	CRT 640x480
;		CRT 768x512̎͂
;		(69.5519MHz/2)/(8*138)=31.500kHz	R20L=$16 HRL=0
;		(69.5519MHz/2)/(8*138*568)=55.46Hz
;		138,15,26,80,17		80/138=0.5797
;		568,6,51,480,31		480/568=0.8451
;

	.text
	.even
crtmod_table_1:
;CRT
;			  size    2nd R20H	;mode color real page
	crtmod_param_1	 512, 512,  0, $04	;   0,   16,1024,   1
	crtmod_param_1	 512, 512,  1, $04	;   1,   16,1024,   1
	crtmod_param_1	 256, 256,  2, $04	;   2,   16,1024,   1
	crtmod_param_1	 256, 256,  3, $04	;   3,   16,1024,   1
	crtmod_param_1	 512, 512,  0, $00	;   4,   16, 512,   4
	crtmod_param_1	 512, 512,  1, $00	;   5,   16, 512,   4
	crtmod_param_1	 256, 256,  2, $00	;   6,   16, 512,   4
	crtmod_param_1	 256, 256,  3, $00	;   7,   16, 512,   4
	crtmod_param_1	 512, 512,  0, $01	;   8,  256, 512,   2
	crtmod_param_1	 512, 512,  1, $01	;   9,  256, 512,   2
	crtmod_param_1	 256, 256,  2, $01	;  10,  256, 512,   2
	crtmod_param_1	 256, 256,  3, $01	;  11,  256, 512,   2
	crtmod_param_1	 512, 512,  0, $03	;  12,65536, 512,   1
	crtmod_param_1	 512, 512,  1, $03	;  13,65536, 512,   1
	crtmod_param_1	 256, 256,  2, $03	;  14,65536, 512,   1
	crtmod_param_1	 256, 256,  3, $03	;  15,65536, 512,   1
	crtmod_param_1	 768, 512,  4, $04	;  16,   16,1024,   1
	crtmod_param_1	1024, 424,  5, $04	;  17,   16,1024,   1
	crtmod_param_1	1024, 848,  6, $04	;  18,   16,1024,   1
	crtmod_param_1	 640, 480,  7, $04	;  19,   16,1024,   1
	crtmod_param_1	 768, 512,  4, $01	;  20,  256, 512,   2
	crtmod_param_1	1024, 424,  5, $01	;  21,  256, 512,   2
	crtmod_param_1	1024, 848,  6, $01	;  22,  256, 512,   2
	crtmod_param_1	 640, 480,  7, $01	;  23,  256, 512,   2
	crtmod_param_1	 768, 512,  4, $03	;  24,65536, 512,   1
	crtmod_param_1	1024, 424,  5, $03	;  25,65536, 512,   1
	crtmod_param_1	1024, 848,  6, $03	;  26,65536, 512,   1
	crtmod_param_1	 640, 480,  7, $03	;  27,65536, 512,   1
;LCD
;			  size    2nd R20H	;mode color real page
	crtmod_param_1	 512, 512,  8, $04	;   0,   16,1024,   1
	crtmod_param_1	 512, 512,  8, $04	;   1,   16,1024,   1
	crtmod_param_1	 256, 256, 10, $04	;   2,   16,1024,   1
	crtmod_param_1	 256, 256, 11, $04	;   3,   16,1024,   1
	crtmod_param_1	 512, 512,  8, $00	;   4,   16, 512,   4
	crtmod_param_1	 512, 512,  8, $00	;   5,   16, 512,   4
	crtmod_param_1	 256, 256, 10, $00	;   6,   16, 512,   4
	crtmod_param_1	 256, 256, 11, $00	;   7,   16, 512,   4
	crtmod_param_1	 512, 512,  8, $01	;   8,  256, 512,   2
	crtmod_param_1	 512, 512,  8, $01	;   9,  256, 512,   2
	crtmod_param_1	 256, 256, 10, $01	;  10,  256, 512,   2
	crtmod_param_1	 256, 256, 11, $01	;  11,  256, 512,   2
	crtmod_param_1	 512, 512,  8, $03	;  12,65536, 512,   1
	crtmod_param_1	 512, 512,  8, $03	;  13,65536, 512,   1
	crtmod_param_1	 256, 256, 10, $03	;  14,65536, 512,   1
	crtmod_param_1	 256, 256, 11, $03	;  15,65536, 512,   1
	crtmod_param_1	 768, 512, 12, $04	;  16,   16,1024,   1
	crtmod_param_1	 768, 600, 13, $04	;  17,   16,1024,   1
	crtmod_param_1	 768,1024, 14, $04	;  18,   16,1024,   1
	crtmod_param_1	 640, 480, 15, $04	;  19,   16,1024,   1
	crtmod_param_1	 768, 512, 12, $01	;  20,  256, 512,   2
	crtmod_param_1	 768, 600, 13, $01	;  21,  256, 512,   2
	crtmod_param_1	 768,1024, 14, $01	;  22,  256, 512,   2
	crtmod_param_1	 640, 480, 15, $01	;  23,  256, 512,   2
	crtmod_param_1	 768, 512, 12, $03	;  24,65536, 512,   1
	crtmod_param_1	 768, 600, 13, $03	;  25,65536, 512,   1
	crtmod_param_1	 768,1024, 14, $03	;  26,65536, 512,   1
	crtmod_param_1	 640, 480, 15, $03	;  27,65536, 512,   1

	.text
	.even
crtmod_table_2:
;CRT
;			 HT HS HB  HD HF   VT VS  VB  VD VF R20L HRL R08
	crtmod_param_2	 92,10,12, 64, 6, 568, 6, 35,512,15, $15, 0, $1B	; 0  512x512   (69.552MHz/3)/(8* 92)=31.500kHz  /568=55.458Hz
	crtmod_param_2	 76, 4, 6, 64, 2, 260, 2, 15,240, 3, $05, 0, $2C	; 1  512x512   (38.864MHz/4)/(8* 76)=15.980kHz  /260=61.462Hz
	crtmod_param_2	 46, 5, 6, 32, 3, 568, 6, 35,512,15, $10, 0, $1B	; 2  256x256   (69.552MHz/6)/(8* 46)=31.500kHz  /568=55.458Hz  X^2xǂ
	crtmod_param_2	 38, 2, 3, 32, 1, 260, 2, 15,240, 3, $00, 0, $24	; 3  256x256   (38.864MHz/8)/(8* 38)=15.980kHz  /260=61.462Hz  X^2xǂ
	crtmod_param_2	138,15,18, 96, 9, 568, 6, 35,512,15, $16, 0, $1B	; 4  768x512   (69.552MHz/2)/(8*138)=31.500kHz  /568=55.458Hz
	crtmod_param_2	176,16,20,128,12, 465, 8, 25,424, 8, $16, 0, $1B	; 5 1024x424   (69.552MHz/2)/(8*176)=24.699kHz  /465=53.116Hz
	crtmod_param_2	176,16,20,128,12, 465, 8, 25,424, 8, $1A, 0, $1B	; 6 1024x848   (69.552MHz/2)/(8*176)=24.699kHz  /465=53.116Hz  C^[[X
	crtmod_param_2	138,15,26, 80,17, 568, 6, 51,480,31, $16, 0, $1B	; 7  640x480   (69.552MHz/2)/(8*138)=31.500kHz  /568=55.458Hz
;LCD
;			 HT HS HB  HD HF   VT VS  VB  VD VF R20L HRL R08
	crtmod_param_2	 82, 6,10, 64, 2, 625, 2, 66,512,45, $15, 0, $1B	; 8  512x512   (69.552MHz/3)/(8* 82)=35.341kHz  /625=56.546Hz
	crtmod_param_2	 92, 8,14, 64, 6, 625, 3, 65,512,45, $16, 0, $1B	; 9  512x512   (69.552MHz/2)/(8* 92)=47.250kHz  /625=75.600Hz  XvCgs
	crtmod_param_2	 42, 3, 5, 32, 2, 625, 2, 66,512,45, $10, 0, $1B	;10  256x256   (69.552MHz/6)/(8* 42)=34.500kHz  /625=55.200Hz  X^2xǂ
	crtmod_param_2	 46, 4, 7, 32, 3, 625, 3, 65,512,45, $11, 1, $1B	;11  256x256   (69.552MHz/4)/(8* 46)=47.250kHz  /625=75.600Hz  X^2xǂ
	crtmod_param_2	124, 9,15, 96, 4, 625, 2, 66,512,45, $16, 0, $1B	;12  768x512   (69.552MHz/2)/(8*124)=35.056kHz  /625=56.090Hz
	crtmod_param_2	124, 9,15, 96, 4, 625, 2, 22,600, 1, $16, 0, $1B	;13  768x600   (69.552MHz/2)/(8*124)=35.056kHz  /625=56.090Hz
	crtmod_param_2	124, 9,15, 96, 4, 625, 2, 66,512,45, $1A, 0, $1B	;14  768x1024  (69.552MHz/2)/(8*124)=35.056kHz  /625=56.090Hz  C^[[X
	crtmod_param_2	100,12, 6, 80, 2, 525, 2, 32,480,11, $17, 0, $1B	;15  640x480   (50.350MHz/2)/(8*100)=31.469kHz  /525=59.940Hz  Compact
										;  SVGA 56Hz   (36.000MHz/1)/(8*128)=35.156kHz  /625=56.250Hz
										;  SVGA 75Hz   (49.500MHz/1)/(8*132)=46.875kHz  /625=75.000Hz
										;   VGA 60Hz   (50.350MHz/2)/(8*100)=31.469kHz  /525=59.940Hz

	PATCH_END



;----------------------------------------------------------------
;
;	DMA]JnÕLbVtbV
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF8284 2F00                   move.l	d0,-(sp)
;		00FF8286 0C3800010CBC           cmpi.b	#$01,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
;		00FF828C 6314                   bls.s	$00FF82A2
;		00FF828E 4E7A0002               movec.l	cacr,d0
;		00FF8292 807C0808               or.w	#$0808,d0
;		00FF8296 4E7B0002               movec.l	d0,cacr
;		00FF829A C07CF7F7               and.w	#$F7F7,d0
;		00FF829E 4E7B0002               movec.l	d0,cacr
;		00FF82A2 201F                   move.l	(sp)+,d0
;		00FF82A4 4E75                   rts
;
;		00FF82A6
;----------------------------------------------------------------

	PATCH_DATA	dmaCacheFlush,$00FF8284,$00FF82A6,$2F000C38

	jmp	cacheFlush

	PATCH_END



;----------------------------------------------------------------
;
;	SCSI@킪ڑĂƋNłȂ
;	https://stdkmd.net/bugsx68k/#rom_fds120
;
;	_S_INQUIRY_S_REQUEST̃AP[VȂ
;	InquiryEVPD0̂ƂAP[V5oCgȏłȂ΂ȂȂ̂1oCgɂȂĂ
;	Request SensẽZXf[^̓G[NXɂ4oCg܂8oCgȏゾAP[V3oCgɂȂĂ
;	NɃAP[Ṽf[^ԂƂSCSI@킪ڑēdĂƃnOAbv
;	Inquiry1ڂ5oCgv2ڂɒǉf[^+5oCgv̂
;	ŏ36oCgvĂǂ2ɕ
;	Ql:FDS021.LZH/FDS120T.DOC
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF93A2 7603                   moveq.l	#$03,d3
;		00FF93A4
;----------------------------------------------------------------

	PATCH_DATA	s_request_3_1st,$00FF93A2,$00FF93A4,$760343F8

	moveq.l	#8,d3

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF93F2 7601                   moveq.l	#$01,d3
;		00FF93F4
;----------------------------------------------------------------

	PATCH_DATA	s_inquiry_1,$00FF93F2,$00FF93F4,$76014E4F

	moveq.l	#5,d3

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF9522 7603                   moveq.l	#$03,d3
;		00FF9524
;----------------------------------------------------------------

	PATCH_DATA	s_request_3_2nd,$00FF9522,$00FF9524,$76034E4F

	moveq.l	#8,d3

	PATCH_END



;----------------------------------------------------------------
;
;	ubN2048oCgSCSI@(CD-ROMȂ)Nł悤ɂ
;
;	FORMAT.XɂSCSI HDɏ܂ꂽSCSI-BIOS͑ΉĂȂA
;	ւ̂͑gݍݍς݂SCSI-BIOS̃x3ȉ̂ƂȂ̂ŖȂ
;
;	̕SCSIINROM/SCSIEXROMƂɃRs[
;	SCSIINROM/SCSIEXROMIPLROM 1.3ƓɎgƂ͌Ȃ̂ŁA
;	IPLROM 1.3ɂȂOt̃Tu[`ĂяoƂ͂łȂ
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FF93B2 1011                   move.b	(a1),d0			;ZXG[R[h
;		00FF93B4 02000070               andi.b	#$70,d0
;		00FF93B8 0C000070               cmpi.b	#$70,d0
;		00FF93BC 6622                   bne.s	$00FF93E0		;gZXL[ȂΎs
;		00FF93BE 10290002               move.b	$0002(a1),d0		;ZXL[
;		00FF93C2 67B0                   beq.s	$00FF9374		;No Sense̓gC
;		00FF93C4 B03C0001               cmp.b	#$01,d0
;		00FF93C8 67AA                   beq.s	$00FF9374		;Recovered Error̓gC
;		00FF93CA B03C0006               cmp.b	#$06,d0
;		00FF93CE 67A4                   beq.s	$00FF9374		;Unit Attention̓gC
;		00FF93D0 B03C0002               cmp.b	#$02,d0
;		00FF93D4 679E                   beq.s	$00FF9374		;Not Ready̓gC
;		00FF93D6 6008                   bra.s	$00FF93E0		;ȊO͎s
;		00FF93D8
;----------------------------------------------------------------

	PATCH_DATA	scsi2048_1st,$00FF93B2,$00FF93D8,$10110200

;<a1.l:Request Sensẽobt@
	moveq.l	#$70,d0
	and.b	(a1),d0			;G[NX
	cmp.b	#$70,d0
	bne	($00FF93E0)PATCH_ZL	;g`łȂΎs
	moveq.l	#$F8,d0
	add.b	2(a1),d0		;ZXL[-8
	bcs	($00FF93E0)PATCH_ZL	;8ȏ͎s
	btst.b	d0,#$01+$02+$40+$04	;0=No Sense,1=Recovered Error,6=Unit Attention,2=Not Ready
	bne	($00FF9374)PATCH_ZL	;̓gC
	bra	($00FF93E0)PATCH_ZL	;ȊO͎s

;<d5.l:ubN
scsi2048_calc_1:
					;d5=$0100 $0200 $0400 $0800
	lsr.w	#8,d5			;d5=$0001 $0002 $0004 $0008
	move.w	d5,d0			;d0=$0001 $0002 $0004 $0008
	lsr.w	#3,d0			;d0=$0000 $0000 $0000 $0001
	sub.w	d0,d5			;d5=$0001 $0002 $0004 $0007
	lsr.w	#1,d5			;d5=$0000 $0001 $0002 $0003
	rts

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF943A E08D                   lsr.l	#8,d5
;		00FF943C E28D                   lsr.l	#1,d5			;2560,5121,10242
;		00FF943E
;----------------------------------------------------------------

	PATCH_DATA	scsi2048_2nd,$00FF943A,$00FF943E,$E08DE28D

	PATCH_bsr	scsi2048_1st,scsi2048_calc_1

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF9574 E08D                   lsr.l	#8,d5
;		00FF9576 E28D                   lsr.l	#1,d5			;2560,5121,10242
;		00FF9578
;----------------------------------------------------------------

	PATCH_DATA	scsi2048_3rd,$00FF9574,$00FF9578,$E08DE28D

	PATCH_bsr	scsi2048_1st,scsi2048_calc_1

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FF969C 0C450003               cmpi.w	#$0003,d5
;		00FF96A0 6406                   bcc.s	$00FF96A8
;		00FF96A2 EAAA                   lsr.l	d5,d2
;		00FF96A4 EAAB                   lsr.l	d5,d3
;		00FF96A6 4E75                   rts
;
;		00FF96A8 E48A                   lsr.l	#2,d2
;		00FF96AA E48B                   lsr.l	#2,d3
;		00FF96AC 4E75                   rts
;
;		00FF96AE
;----------------------------------------------------------------

	PATCH_DATA	scsi2048_4th,$00FF969C,$00FF96AE,$0C450003

;SCSI@̃ubNɉăubNԍƃubN𒲐
;	؂ȂƂ̓ubNԍƃubNuꂼvubN̔{܂Ő؂グ
;<d2.l:ubNԍ(256oCg/ubN)
;<d3.l:ubN(256oCg/ubN)
;<d5.w:ubN(0=256,1=512,2=1024,3=2048)
;>d2.l:ubNԍ
;>d3.l:ubN
	moveq.l	#-1,d0
	lsl.l	d5,d0
	not.l	d0
	add.l	d0,d2
	add.l	d0,d3
	lsr.l	d5,d2
	lsr.l	d5,d3
	rts

	PATCH_END



;----------------------------------------------------------------
;
;	_MS_LIMITY͈̔͂1007܂łݒłȂ
;	https://stdkmd.net/bugsx68k/#rom_mslimit
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FFABA4 B27C03F0               cmp.w	#$03F0,d1
;		00FFABA8
;----------------------------------------------------------------

	PATCH_DATA	mslimit_1st,$00FFABA4,$00FFABA8,$B27C03F0

	cmp.w	#$0400,d1

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFABB4 B47C03F0               cmp.w	#$03F0,d2
;		00FFABB8
;----------------------------------------------------------------

	PATCH_DATA	mslimit_2nd,$00FFABB4,$00FFABB8,$B47C03F0

	cmp.w	#$0400,d2

	PATCH_END



;----------------------------------------------------------------
;
;	_MS_ONTM̃LbV
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FFAC72 0C3800010CBC           cmpi.b	#$01,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
;		00FFAC78 630C                   bls.s	$00FFAC86
;		00FFAC7A 4E7A0002               movec.l	cacr,d0
;		00FFAC7E 2F00                   move.l	d0,-(sp)
;		00FFAC80 7001                   moveq.l	#$01,d0			;EI=1,ED=0
;		00FFAC82 4E7B0002               movec.l	d0,cacr
;		00FFAC86
;----------------------------------------------------------------

	PATCH_DATA	msOntmCache_1st,$00FFAC72,$00FFAC86,$0C380001

	jsr	cacheOnI	;f[^LbVOFF,߃LbVON
	move.l	d0,-(sp)
	bra	($00FFAC86)PATCH_ZL

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFACE8 0C3800010CBC           cmpi.b	#$01,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
;		00FFACEE 6306                   bls.s	$00FFACF6
;		00FFACF0 201F                   move.l	(sp)+,d0
;		00FFACF2 4E7B0002               movec.l	d0,cacr
;		00FFACF6
;----------------------------------------------------------------

	PATCH_DATA	msOntmCache_2nd,$00FFACE8,$00FFACF6,$0C380001

	move.l	(sp)+,d2
	jsr	cacheSet	;LbVݒ
	bra	($00FFACF6)PATCH_ZL

	PATCH_END



;----------------------------------------------------------------
;
;	_G_CLR_ON
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;	00FFB326 48E76040               movem.l	d1-d2/a1,-(sp)
;	00FFB32A 33FC002000E82600       move.w	#$0020,$00E82600	;[$00E82600].w:VCN /\(Ys|AH|VHT|EXON|HP|BP|GG|GT|BCON|SON|TON|GS4|GS3|GS2|GS1|GS0)
;	00FFB332
;----------------------------------------------------------------

	PATCH_DATA	g_clr_on,$00FFB326,$00FFB332,$48E76040

	jmp	g_clr_on

	PATCH_TEXT

;----------------------------------------------------------------
;IOCSR[$90 _G_CLR_ON
;	OtBbNʂ̏ƃpbgƕ\ON
;----------------------------------------------------------------
	.text
	.even
g_clr_on:
g_clr_on_regs	reg	d0/d1/d2/d3/a0/a1/a4/a6
	movem.l	g_clr_on_regs,-(sp)

	lea.l	$00E88000,a6
o	reg	-$00E88000(a6)

;p[^
	move.b	$093C.w,d1		;ʃ[h
	bsr	crtmod_get_param_1	;p[^1̃AhX߂
;<a4.l:p[^1
	moveq.l	#7,d3
	and.b	crtmod_param_1_r20h(a4),d3	;[h0`7
;<d3.w:[h0`7

;\OFF
	andi.w	#.notw.%11111,($00E82600)o	;OtBbNOFF
	move.b	#(1<<3)+(3),($00E80028)o	;MPUDA[h3

;OtBbNVRAM
	lea.l	$00C00000,a0
	moveq.l	#0,d0
	moveq.l	#-1,d1			;1024*512/8=65536
@@:	move.l	d0,(a0)+
	move.l	d0,(a0)+
	dbra	d1,@b

;OtBbNpbg
;<d3.w:[h0`7
	bsr	init_gpalet		;OtBbNpbg
;?d0/d1/d2/a0/a1

;`y[W擪AhXAỸItZbgAF-1
;<d3.w:[h0`7
;[h0B512x512hbgA16FA4y[W
	moveq.l	#%01111,d0		;512x512hbg
	movea.w	#2*512,a0		;ỸItZbg=2*512
	moveq.l	#$0F,d1			;F-1=15
	cmp.w	#1,d3
	blo	@f
;[h1B512x512hbgA256FA2y[W
	st.b	d1			;F-1=255
	beq	@f
;[h2`3B512x512hbgA65536FA1y[W
	ext.w	d1			;F-1=65535
	cmp.w	#3,d3
	bls	@f
;[h4`7B1024x1024hbgA16FA1y[W
	moveq.l	#%10000,d0		;1024x1024hbg
	adda.l	a0,a0			;ỸItZbg=2*1024
	moveq.l	#$0F,d1			;F-1=15
@@:	move.l	#$00C00000,$095C.w	;[$095C.w].l:OtBbN`y[W擪AhX(_SET_PAGEŐݒ)
	move.l	a0,$0960.w		;[$0960.w].l:OtBbNVRAMỸItZbg
	move.w	d1,$0964.w		;[$0964.w].w:OtBbNʂ̐F-1(0=OtBbNʎgps)
;<d0.w:%01111=512x512hbgA%10000=1024x1024hbg

;\ON
;<d0.w:%01111=512x512hbgA%10000=1024x1024hbg
;<d3.w:[h0`7
	move.b	d3,($00E80028)o		;CRTCDA[h0`7
	move.w	d3,($00E82400)o		;[h0`7
	or.w	d0,($00E82600)o		;OtBbNON
	movem.l	(sp)+,g_clr_on_regs
	rts

;----------------------------------------------------------------
;OtBbNpbg
;<d3.w:[h
;?d0/d1/d2/a0/a1
	.text
	.even
init_gpalet:
	lea.l	$00E82000,a0		;OtBbNpbg
	cmp.w	#1,d3
	blo	init_gpalet_16		;[h0B16F
	beq	init_gpalet_256		;[h1B256F
	cmp.w	#3,d3
	bls	init_gpalet_65536	;[h2`3B65536F
;[h4`7B1024x1024hbgA16FA1y[W
;[h0B512x512hbgA16FA4y[W
init_gpalet_16:
	lea.l	gpalet_16(pc),a1
	moveq.l	#16/2-1,d0
@@:	move.l	(a1)+,(a0)+
	dbra	d0,@b
	rts

;[h1B512x512hbgA256FA2y[W
init_gpalet_256:
	lea.l	gpalet_256(pc),a1
	moveq.l	#256/2-1,d0
@@:	move.l	(a1)+,(a0)+
	dbra	d0,@b
	rts

;[h2`3B512x512hbgA65536FA1y[W
init_gpalet_65536:
	move.l	#$00010001,d1
	move.l	#$02020202,d2
	moveq.l	#256/2-1,d0
@@:	move.l	d1,(a0)+
	add.l	d2,d1
	dbra	d0,@b
	rts

;----------------------------------------------------------------
GRB	.macro	g,r,b
	.dc.w	((g)<<11)|((r)<<6)|((b)<<1)
	.endm

;----------------------------------------------------------------
;OtBbN16Fpbg
	.text
	.even
gpalet_16:
	GRB	0,0,0
	GRB	10,10,10
	GRB	0,0,16
	GRB	0,0,31
	GRB	0,16,0
	GRB	0,31,0
	GRB	0,16,16
	GRB	0,31,31
	GRB	16,0,0
	GRB	31,0,0
	GRB	16,0,16
	GRB	31,0,31
	GRB	16,16,0
	GRB	31,31,0
	GRB	21,21,21
	GRB	31,31,31

;----------------------------------------------------------------
;OtBbN256Fpbg
	.text
	.even
gpalet_256:
  .irp %gg,0,10,21,31
    .irp %rr,0,4,9,13,18,22,27,31
      .irp %bb,0,4,9,13,18,22,27,31
	GRB	%gg,%rr,%bb
      .endm
    .endm
  .endm

	PATCH_END



;----------------------------------------------------------------
;
;	_GPALET65536F[h̃pbg𐳂擾łȂ
;	https://stdkmd.net/bugsx68k/#rom_gpalet
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FFB740 16300000               move.b	$00(a0,d0.w),d3
;		00FFB744
;----------------------------------------------------------------

	PATCH_DATA	gpalet,$00FFB740,$00FFB744,$16300000

	move.b	2(a0,d0.w),d3

	PATCH_END



;----------------------------------------------------------------
;
;	IOCS _SYS_STAT
;
;	_SYS_STAT̃R[hԈĂ
;	https://stdkmd.net/bugsx68k/#rom_sysstat
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FFC75A 48E76000               movem.l	d1-d2,-(sp)
;			:
;		00FFC818
;----------------------------------------------------------------

	PATCH_DATA	sysstat,$00FFC75A,$00FFC818,$48E76000

	jmp	iocsSysStat

	PATCH_TEXT

;----------------------------------------------------------------
;IOCS _SYS_STAT
;$AC VXe̎擾Ɛݒ
;<d1.w:[h
;	0	MPUXe[^X̎擾
;		>d0.l:MPUXe[^X
;			bit0`7		MPU̎(0=68000,3=68030,4=68040,6=68060)
;			bit14		MMU̗L(0=Ȃ,1=)
;			bit15		FPU/FPCP̗L(0=Ȃ,1=)
;			bit16`31	NbNXs[h*10
;	1	LbVԂ̎擾
;		>d0.l:݂̃LbV
;			bit0	߃LbV̏(0=,1=L)
;			bit1	f[^LbV̏(0=,1=L)
;	2	LbV̏ԂSRAMݒlɂ
;		>d0.l:ݒ̃LbV
;			bit0	߃LbV̏(0=,1=L)
;			bit1	f[^LbV̏(0=,1=L)
;	3	LbVtbV
;	4	LbVݒ
;		<d2.w:LbV̐ݒ
;			bit0	߃LbV̏(0=,1=L)
;			bit1	f[^LbV̏(0=,1=L)
;		>d0.l:ݒÕLbV
;			bit0	߃LbV̏(0=,1=L)
;			bit1	f[^LbV̏(0=,1=L)
iocsSysStat:
	moveq.l	#-1,d0
	cmpi.b	#2,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	bhs	2f			;020/030/040/060
;000/010
	tst.w	d1
	bne	9f			;000/010d1!=0̂Ƃ̓G[
2:	cmp.w	#4,d1
	bhi	9f
	move.w	d1,-(sp)
	add.w	d1,d1
	move.w	10f(pc,d1.w),d1
	jsr	10f(pc,d1.w)
	move.w	(sp)+,d1
9:	rts

10:
	.dc.w	mpuStat-10b		;0:MPUXe[^X̎擾
	.dc.w	cacheGet-10b		;1:LbVԂ̎擾
	.dc.w	cacheLoad-10b		;2:LbV̏ԂSRAMݒlɂ
	.dc.w	cacheFlush-10b		;3:LbVtbV
	.dc.w	cacheSet-10b		;4:LbVݒ

;----------------------------------------------------------------
;IOCS _SYS_STAT		0
;MPUXe[^X̎擾
;>d0.l:MPUXe[^X
;	bit0`7		MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
;	bit14		MMU̗L(0=Ȃ,1=)
;	bit15		FPU/FPCP̗L(0=Ȃ,1=)
;	bit16`31	NbNXs[h*10
mpuStat:
	moveq.l	#12,d0
	cmpi.b	#2,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	blo	@f
;020/030/040/060
	moveq.l	#6,d0
@@:	mulu.w	$0CB8.w,d0		;[$0CB8.w].w:[11,12,13]ROMvNbN($034210*250/3,$056E16.67*250/3,$104D25*500/3)
					;MHzl*250/3*12=MHzl*1000A܂́AMHzl*500/3*6=MHzl*1000
	add.l	#50,d0
	divu.w	#100,d0			;MHzl*10
	swap.w	d0			;ssssssss ssssssss ........ ........
	clr.w	d0			;ssssssss ssssssss 00000000 00000000
	tst.b	$0CBE.w			;[$0CBE.w].b:MMU̗L(0=Ȃ,-1=)
	sne.b	d0			;ssssssss ssssssss 00000000 mmmmmmmm
	ror.w	#1,d0			;ssssssss ssssssss m0000000 0mmmmmmm
	tst.b	$0CBD.w			;[$0CBD.w].b:FPU/FPCP̗L(0=Ȃ,-1=)
	sne.b	d0			;ssssssss ssssssss m0000000 ffffffff
	ror.w	#1,d0			;ssssssss ssssssss fm000000 0fffffff
	move.b	$0CBC.w,d0		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
					;ssssssss ssssssss fm000000 pppppppp
	rts

;----------------------------------------------------------------
;IOCS _SYS_STAT		1
;LbVԂ̎擾
;>d0.l:݃LbV
;	bit0	߃LbV̏(0=,1=L)
;	bit1	f[^LbV̏(0=,1=L)
;	000/010̂Ƃ0Ԃ
cacheGet:
	moveq.l	#0,d0
	cmpi.b	#2,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	blo	9f
;020/030/040/060
	.cpu	68030
	movec.l	cacr,d0
	.cpu	68000
	cmpi.b	#4,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	bhs	4f
;020/030				;........ ........ .......d .......i
	ror.l	#1,d0			;i....... ........ ........ d.......
	rol.b	#1,d0			;i....... ........ ........ .......d
	bra	8f

;040/060				;d....... ........ i....... ........
4:	swap.w	d0			;i....... ........ d....... ........
	rol.w	#1,d0			;i....... ........ ........ .......d
8:	rol.l	#1,d0			;........ ........ ........ ......di
	and.l	#3,d0			;00000000 00000000 00000000 000000di
9:	rts

;----------------------------------------------------------------
;IOCS _SYS_STAT		2
;LbV̏ԂSRAMݒlɂ
;>d0.l:ݒ̃LbV
;	bit0	߃LbV̏(0=,1=L)
;	bit1	f[^LbV̏(0=,1=L)
;	000/010̂Ƃ0Ԃ
cacheLoad:
	move.l	d2,-(sp)
	moveq.l	#0,d2			;Ô
	move.b	$00ED0090,d2		;[$00ED0090].b:SRAM [13]LbV(------|f[^|)
	bsr	cacheSet		;LbVݒ
	move.l	(sp)+,d2
	rts

;----------------------------------------------------------------
;IOCS _SYS_STAT		3
;LbVtbV
cacheFlush:
	cmpi.b	#2,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	blo	9f
;020/030/040/060
	cmpi.b	#4,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	bhs	4f
;020/030
	move.l	d0,-(sp)
	.cpu	68030
	movec.l	cacr,d0
	or.w	#$0808,d0
	movec.l	d0,cacr
	and.w	#$F7F7,d0
	movec.l	d0,cacr
	.cpu	68000
	move.l	(sp)+,d0
9:	rts

;040/060
4:	.cpu	68040
	cpusha	bc
	.cpu	68000
	rts

;----------------------------------------------------------------
;IOCS _SYS_STAT		4
;LbVݒ
;<d2.l:LbV̐ݒ
;	bit0	߃LbV̏(0=,1=L)
;	bit1	f[^LbV̏(0=,1=L)
;	000/010̂Ƃ͖Ӗ
;>d0.l:ݒÕLbV
;	bit0	߃LbV̏(0=,1=L)
;	bit1	f[^LbV̏(0=,1=L)
;	000/010̂Ƃ0Ԃ
cacheSet:
	bsr	cacheGet		;LbVԂ̎擾
	cmpi.b	#2,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	blo	9f
;020/030/040/060
	move.l	d1,-(sp)
	move.w	d2,-(sp)		;ƃTCYɒ
	cmpi.b	#4,$0CBC.w		;[$0CBC.w].b:[13]MPU̎(0=68000,1=68010,2=68020,3=68030,4=68040,6=68060)
	bhs	4f
;020/030
	moveq.l	#1,d1
	and.w	d2,d1			;00000000 00000000 00000000 0000000i
	and.w	#2,d2			;........ ........ 00000000 000000d0
	neg.w	d2			;........ ........ dddddddd ddddddd0
	and.w	#$2100,d2		;........ ........ 00d0000d 00000000
	or.w	d2,d1			;........ ........ 00d0000d 0000000i
	.cpu	68030
	movec.l	d1,cacr
	.cpu	68000
	bra	8f

;040/060
4:	.cpu	68040
	movec.l	cacr,d1
	lsr.w	#1,d2			;FEDCBA98 76543210 FEDCBA98 76543210 i
	addx.w	d1,d1			;FEDCBA98 76543210 EDCBA987 6543210i .
	ror.w	#1,d1			;FEDCBA98 76543210 iEDCBA98 76543210 .
	lsr.w	#1,d2			;FEDCBA98 76543210 iEDCBA98 76543210 d
	addx.l	d1,d1			;EDCBA987 6543210i EDCBA987 6543210d .
	ror.l	#1,d1			;dEDCBA98 76543210 iEDCBA98 76543210 .
	movec.l	d1,cacr
	move.w	(sp),d2
	not.w	d2
	and.w	d0,d2			;bit1=f[^LbVONOFF,bit0=߃LbVONOFF
	beq	8f
	subq.w	#2,d2
	bhi	3f
	blo	1f
	cpusha	dc			;2:f[^LbVOFFɂƂvbVĂ疳
	bra	8f

3:	cpusha	dc			;3:f[^LbVOFFɂƂvbVĂ疳
1:	cinva	ic			;1:3:߃LbVOFFɂƂ
	.cpu	68000
8:	move.w	(sp)+,d2
	move.l	(sp)+,d1
9:	rts

;----------------------------------------------------------------
;LbVOFF
;>d0.l:ݒÕLbV
;	bit0	߃LbV̏(0=,1=L)
;	bit1	f[^LbV̏(0=,1=L)
;	000/010̂Ƃ0Ԃ
cacheOff:
	move.l	d2,-(sp)
	moveq.l	#0,d2
	bsr	cacheSet		;LbVݒ
	move.l	(sp)+,d2
	rts

;----------------------------------------------------------------
;f[^LbVOFF,߃LbVON
;>d0.l:ݒÕLbV
;	bit0	߃LbV̏(0=,1=L)
;	bit1	f[^LbV̏(0=,1=L)
;	000/010̂Ƃ0Ԃ
cacheOnI:
	move.l	d2,-(sp)
	moveq.l	#1,d2			;f[^LbVOFF,߃LbVON
	bsr	cacheSet		;LbVݒ
	move.l	(sp)+,d2
	rts

	PATCH_END



;----------------------------------------------------------------
;
;	_SP_INIT ŃoXG[ (ROM 1.0/1.1/1.2/1.3)
;	https://stdkmd.net/bugsx68k/#rom_spinit
;
;	Ǐ
;	XvCg\łȂƂ _SP_INIT  -1 ԂoXG[Ŏ~܂邱ƂB
;
;	
;	ʃ[h 18 (1024x848) ܂͉ʃ[h 19 (640x480; VGA [h)  _SP_INIT ĂяoƂB
;
;	
;	n[hEFA̐ŁACRTC  R20 ($00E80028) ̉ 5 rbg %1??1? ̂ƂAXvCg\łȂB
;	XvCg\łȂƂAXvCgXN[WX^ ($00EB0000`$00EB07FF) ܂
;	XvCg PCGEeLXgGA ($00EB8000`$00EBFFFF) ɃANZXƁAoXG[B
;	XvCg֘A IOCS R[́Aʃ[h 16 (768x512) Ɖʃ[h 17 (1024x424)  %10110 ̂ƂAXvCg\łȂƔfB
;	ʃ[h 18  %11010 Ɖʃ[h 19  %10111 ܂ %1001?  %10111  %11?1? ̓XvCg\łƌĔfA
;	_SP_INIT ANZXłȂXvCgXN[WX^悤ƂăoXG[B
;
;	⑫
;	ʃ[h 17 (1024x424) Ɖʃ[h 18 (1024x848)  ROM 1.0 炠邪JB
;	ʃ[h 19 (640x480; VGA [h)  X68000 Compact  ROM 1.2 ŒǉꂽB
;
;	
;	̃oXG[̓G~[^ł͍ČȂƂB
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FFCC9E 303900E80028           move.w	$00E80028,d0		;[$00E80028].w:CRTC R20 [h/𑜓x(𑜓x|𑜓x|𑜓x)
;		00FFCCA4 024000FF               andi.w	#$00FF,d0
;		00FFCCA8 0C400016               cmpi.w	#$0016,d0
;		00FFCCAC 6606                   bne.s	$00FFCCB4
;		00FFCCAE 70FF                   moveq.l	#$FF,d0
;		00FFCCB0 588F                   addq.l	#4,sp
;		00FFCCB2 4E75                   rts
;
;		00FFCCB4 7000                   moveq.l	#$00,d0
;		00FFCCB6 4E75                   rts
;
;		00FFCCB8
;----------------------------------------------------------------

	PATCH_DATA	spinit,$00FFCC9E,$00FFCCB8,$303900E8

;XvCg\ł邩
;	XvCg֘AIOCSR[̐擪ŌĂяo
;	\łȂƂ-1ԂIOCSR[畜A
;>d0.l:0=XvCg\ł,-1=XvCg\łȂ
	moveq.l	#%10010,d0
	and.w	$00E80028,d0		;CRTC R20
	cmp.w	#%10010,d0
	bne	@f			;XvCg\ł
;%1??1?BXvCg\łȂ
	moveq.l	#-1,d0			;XvCg\łȂ
	addq.l	#4,sp			;IOCSR[畜A
	rts

;XvCg\ł
@@:	moveq.l	#0,d0			;XvCg\ł
	rts

	PATCH_END



;----------------------------------------------------------------
;
;	IOCS _SCSIDRV
;
;	68060Ή
;		SPCTEMP/TCH/TCM/TCL֏ނƂMOVEPgĂ
;		68060̂ƂߗOMOVEPG~[g
;		̂܂܂łȂ삷邪A]vȗO̓fobOƂז
;		68060̂ƂMOVEPWJ
;
;	2048oCg/ubNΉ
;		CD-ROMNł悤ɂ
;		ubN3܂4̂Ƃ2048oCg/ubNƌȂ
;
;	SASI@Ή
;		SASI@ő݂ȂSPC𑀍삵悤ƂSASI|[gɖӖȃf[^𐂂ꗬƂɂȂ
;		SPCSASI@̂ƂIOCS _SCSIDRV͉G[Ԃ
;		IOCS _SCSIDRVo^Ȃ@
;		ĂяoꂽƂofʂ肳邩̈Ⴂ
;		fʂ肳pb`͏Ȃčς
;		fʂ肳ĂȂƂ͂ǂ݂̂pb`𓖂ĂKv
;
;	SCSIINROM/SCSIEXROMsŁASCSI BIOS̃pb`͊SCSI BIOS͈̔͂Ɏ߂
;	SCSIR[̃Wve[ul߂ăpb`
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FFCCB8 48E75062               movem.l	d1/d3/a1-a2/a6,-(sp)
;			:
;		00FFCE0E
;----------------------------------------------------------------

	PATCH_DATA	iocs_scsidrv,$00FFCCB8,$00FFCE0E,$48E75062

;----------------------------------------------------------------
;IOCSR[$F5 _SCSIDRV
;<d1.l:SCSIR[ԍ
;<d3.l:(KvȂƂ)
;<d4.l:(KvȂƂ)^[QbgLUN<<16|^[QbgID
;<a1.l:(KvȂƂ)擪
;>d0.l:0=I,̑=G[R[h
*****	.text
	.even
iocs_scsidrv:
	movem.l	d1/d3/a1-a2/aSPC,-(sp)
	movea.l	($00FF933C)PATCH_ZL(pc),aSPC	;SPCx[XAhX
	moveq.l	#(scsidrv_jt_undef-scsidrv_jt)/2,d0
	cmpa.l	#SPC_IN_BASE,aSPC
	bne	1f			;gSPC
;SPC
	cmpi.b	#$FF,SPC_SSTS(aSPC)	;SASI@̂ƂSASIZbg|[g̃S[Xg$FFBSCSI@̂ƂSPCXe[^X|[g$FFȊO
	beq	2f			;SPCSASI@BG[Ԃ
;SPCSCSI@
;gSPC
1:	cmp.l	d0,d1
	blo	3f			;SCSIR[ԍL
;SCSIR[ԍ
;SPCSASI@
2:	move.l	d0,d1			;`
;SCSIR[ԍL
3:	add.w	d1,d1
	move.w	scsidrv_jt(pc,d1.w),d1
	jsr	scsidrv_jt(pc,d1.w)
	movem.l	(sp)+,d1/d3/a1-a2/aSPC
	rts

;SCSIR[̃Wve[u
scsidrv_jt:
	.dc.w	($00FFCE0E)PATCH_ZL-scsidrv_jt	;SCSIR[$00 _S_RESET
	.dc.w	($00FFCEFC)PATCH_ZL-scsidrv_jt	;SCSIR[$01 _S_SELECT
	.dc.w	($00FFCED6)PATCH_ZL-scsidrv_jt	;SCSIR[$02 _S_SELECTA
	.dc.w	($00FFCFCA)PATCH_ZL-scsidrv_jt	;SCSIR[$03 _S_CMDOUT
	.dc.w	($00FFD5C0)PATCH_ZL-scsidrv_jt	;SCSIR[$04 _S_DATAIN
	.dc.w	($00FFD578)PATCH_ZL-scsidrv_jt	;SCSIR[$05 _S_DATAOUT
	.dc.w	($00FFD0AA)PATCH_ZL-scsidrv_jt	;SCSIR[$06 _S_STSIN
	.dc.w	($00FFD0E8)PATCH_ZL-scsidrv_jt	;SCSIR[$07 _S_MSGIN
	.dc.w	($00FFD126)PATCH_ZL-scsidrv_jt	;SCSIR[$08 _S_MSGOUT
	.dc.w	($00FFD192)PATCH_ZL-scsidrv_jt	;SCSIR[$09 _S_PHASE
	.dc.w	($00FFD1A6)PATCH_ZL-scsidrv_jt	;SCSIR[$0A _S_LEVEL
	.dc.w	($00FFD066)PATCH_ZL-scsidrv_jt	;SCSIR[$0B _S_DATAINI
	.dc.w	($00FFD026)PATCH_ZL-scsidrv_jt	;SCSIR[$0C _S_DATAOUTI
	.dc.w	($00FFD162)PATCH_ZL-scsidrv_jt	;SCSIR[$0D _S_MSGOUTEXT
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$0E `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$0F `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$10 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$11 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$12 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$13 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$14 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$15 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$16 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$17 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$18 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$19 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$1A `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$1B `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$1C `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$1D `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$1E `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$1F `
	.dc.w	($00FFD612)PATCH_ZL-scsidrv_jt	;SCSIR[$20 _S_INQUIRY
	.dc.w	($00FFD742)PATCH_ZL-scsidrv_jt	;SCSIR[$21 _S_READ
	.dc.w	($00FFD79C)PATCH_ZL-scsidrv_jt	;SCSIR[$22 _S_WRITE
	.dc.w	($00FFD92C)PATCH_ZL-scsidrv_jt	;SCSIR[$23 _S_FORMAT
	.dc.w	($00FFD3F0)PATCH_ZL-scsidrv_jt	;SCSIR[$24 _S_TESTUNIT
	.dc.w	($00FFD49C)PATCH_ZL-scsidrv_jt	;SCSIR[$25 _S_READCAP
	.dc.w	($00FFD7FA)PATCH_ZL-scsidrv_jt	;SCSIR[$26 _S_READEXT
	.dc.w	($00FFD860)PATCH_ZL-scsidrv_jt	;SCSIR[$27 _S_WRITEEXT
	.dc.w	($00FFD900)PATCH_ZL-scsidrv_jt	;SCSIR[$28 _S_VERIFYEXT
	.dc.w	($00FFD68A)PATCH_ZL-scsidrv_jt	;SCSIR[$29 _S_MODESENSE
	.dc.w	($00FFD6CA)PATCH_ZL-scsidrv_jt	;SCSIR[$2A _S_MODESELECT
	.dc.w	($00FFD40E)PATCH_ZL-scsidrv_jt	;SCSIR[$2B _S_REZEROUNIT
	.dc.w	($00FFD64E)PATCH_ZL-scsidrv_jt	;SCSIR[$2C _S_REQUEST
	.dc.w	($00FFD9F8)PATCH_ZL-scsidrv_jt	;SCSIR[$2D _S_SEEK
	.dc.w	($00FFD42C)PATCH_ZL-scsidrv_jt	;SCSIR[$2E _S_READI
	.dc.w	($00FFD992)PATCH_ZL-scsidrv_jt	;SCSIR[$2F _S_STARTSTOP
	.dc.w	($00FFD9C4)PATCH_ZL-scsidrv_jt	;SCSIR[$30 _S_SEJECT
	.dc.w	($00FFD70A)PATCH_ZL-scsidrv_jt	;SCSIR[$31 _S_REASSIGN
	.dc.w	($00FFD960)PATCH_ZL-scsidrv_jt	;SCSIR[$32 _S_PAMEDIUM
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$33 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$34 `
	.dc.w	scsidrv_undef-scsidrv_jt	;SCSIR[$35 `
	.dc.w	($00FFDA2C)PATCH_ZL-scsidrv_jt	;SCSIR[$36 _S_DSKINI
	.dc.w	($00FFDA6E)PATCH_ZL-scsidrv_jt	;SCSIR[$37 _S_FORMATB
	.dc.w	($00FFDAA6)PATCH_ZL-scsidrv_jt	;SCSIR[$38 _S_BADFMT
	.dc.w	($00FFDADE)PATCH_ZL-scsidrv_jt	;SCSIR[$39 _S_ASSIGN
scsidrv_jt_undef:
	.dc.w	scsidrv_undef-scsidrv_jt	;`

;`
scsidrv_undef:
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;68060Ή
;<d0.l:f[^
;<aSPC.l:SPCx[XAhX
scsidrv_movep:
	cmpi.b	#6,$0CBC.w		;0=68000,1=68010,2=68020,3=68030,4=68040,6=68060
	beq	@f			;68060BMOVEPgȂ
;68060ȊOBMOVEPg
	movep.l	d0,SPC_TEMP(aSPC)
	rts

;68060BMOVEPgȂ
@@:	rol.l	#8,d0
	move.b	d0,SPC_TEMP(aSPC)
	rol.l	#8,d0
	move.b	d0,SPC_TCH(aSPC)
	rol.l	#8,d0
	move.b	d0,SPC_TCM(aSPC)
	rol.l	#8,d0
	move.b	d0,SPC_TCL(aSPC)
	rts

;----------------------------------------------------------------
;2048oCg/ubNΉ
;<d3.l:ubN
;<d5.b:ubN(0=256,1=512,2=1024,3=2048,4=2048)
;>d3.l:oCg
scsidrv_2048:
	lsl.l	#8,d3
	cmp.b	#3,d5
	bcc	1f
	lsl.l	d5,d3
	bra	2f

1:	lsl.l	#3,d3
2:	rts

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFCF46 01CE0017               movep.l	d0,$0017(a6)
;		00FFCF4A
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_movep_select_1st,$00FFCF46,$00FFCF4A,$01CE0017

	PATCH_bsr	iocs_scsidrv,scsidrv_movep

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFCF96 01CE0017               movep.l	d0,$0017(a6)
;		00FFCF9A
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_movep_select_2nd,$00FFCF96,$00FFCF9A,$01CE0017

	PATCH_bsr	iocs_scsidrv,scsidrv_movep

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFD1CA 01CE0017               movep.l	d0,$0017(a6)
;		00FFD1CE
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_movep_dataouti_msgout,$00FFD1CA,$00FFD1CE,$01CE0017

	PATCH_bsr	iocs_scsidrv,scsidrv_movep

	PATCH_END

  .if 0
;----------------------------------------------------------------
;	ύXO
;		00FFD28C 01CE0017               movep.l	d0,$0017(a6)
;		00FFD290
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_movep_dataini,$00FFD28C,$00FFD290,$01CE0017

	PATCH_bsr	iocs_scsidrv,scsidrv_movep

	PATCH_END
  .endif

;----------------------------------------------------------------
;	ύXO
;		00FFD460 E18B                   lsl.l	#8,d3
;		00FFD462 EBAB                   lsl.l	d5,d3
;		00FFD464
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_2048_readi,$00FFD460,$00FFD464,$E18BEBAB

	PATCH_bsr	iocs_scsidrv,scsidrv_2048

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFD778 E18B                   lsl.l	#8,d3
;		00FFD77A EBAB                   lsl.l	d5,d3
;		00FFD77C
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_2048_read,$00FFD778,$00FFD77C,$E18BEBAB

	PATCH_bsr	iocs_scsidrv,scsidrv_2048

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFD7D2 E18B                   lsl.l	#8,d3
;		00FFD7D4 EBAB                   lsl.l	d5,d3
;		00FFD7D6
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_2048_write,$00FFD7D2,$00FFD7D6,$E18BEBAB

	PATCH_bsr	iocs_scsidrv,scsidrv_2048

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFD83A E18B                   lsl.l	#8,d3
;		00FFD83C EBAB                   lsl.l	d5,d3
;		00FFD83E
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_2048_readext,$00FFD83A,$00FFD83E,$E18BEBAB

	PATCH_bsr	iocs_scsidrv,scsidrv_2048

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFD89C E18B                   lsl.l	#8,d3
;		00FFD89E EBAB                   lsl.l	d5,d3
;		00FFD8A0
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_2048_writeext,$00FFD89C,$00FFD8A0,$E18BEBAB

	PATCH_bsr	iocs_scsidrv,scsidrv_2048

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFDB34 01CE0017               movep.l	d0,$0017(a6)
;		00FFDB38
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_movep_dataout,$00FFDB34,$00FFDB38,$01CE0017

	PATCH_bsr	iocs_scsidrv,scsidrv_movep

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFDB96 01CE0017               movep.l	d0,$0017(a6)
;		00FFDB9A
;----------------------------------------------------------------

	PATCH_DATA	scsidrv_movep_datain,$00FFDB96,$00FFDB9A,$01CE0017

	PATCH_bsr	iocs_scsidrv,scsidrv_movep

	PATCH_END



;----------------------------------------------------------------
;
;	_S_DATAINI
;
;	MC68000Ή
;		8oCgȏMƂMOVE.LŃɏނ̂MC68000ŎgƃAhXG[
;		MC68000̂ƂMOVE.BŃɏ
;
;	Service RequiredΉ
;		f[^CtF[YACKFalseɂȂ̂҂ɃXe[^XtF[YɈڍsn[hfBXN炵
;		tF[Y̕svŊ荞ݗvService RequiredZbg\
;		Service RequiredZbgƓ]fĂ܂FIFOɎcĂf[^󂯎葹˂
;		]Service RequiredZbgĂDREG status EmptyZbgĂȂΓ]p
;		]IƂService RequiredZbgĂĂG[ƌȂȂ
;		Ql
;			52429̃cC[g
;			https://twitter.com/52429/status/1185350392327983104
;
;	ubNΉ
;		$00ED0070bit71̂ƂDREG status Full҂ĂDREG status EmptyɃubNCɓǂݍ
;		IPLROM 1.3ȊOSCSI BIOS͑ΉĂȂ
;		ȂB󂢂ꏊCɎg
;
;	^[QbgΉ
;		^[QbgɑΉ悤Ƃ`Ղ邪[vJE^Ƀ[vɔэނȂǐ삷R[hł͂Ȃ
;		QlɂȂ
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FFD066 48E70002               movem.l	a6,-(sp)
;			:
;		00FFD0AA
;----------------------------------------------------------------

	PATCH_DATA	s_dataini,$00FFD066,$00FFD0AA,$48E70002

;----------------------------------------------------------------
;SCSIR[$0B _S_DATAINI
;	f[^CtF[Y(\tg])
;<d3.l:obt@̒
;<a1.l:obt@̐擪
;<aSPC.l:SPCx[XAhX
;>d0.l:0=I,̑=INTS<<16|PSNS
*****	.text
	.even
s_dataini:
SAVE_REGS	reg	d1/d2/d3/a0/a1/a2/a3/a4/aSPC
	movem.l	SAVE_REGS,-(sp)
	movea.l	($00FF933C)PATCH_ZL(pc),aSPC	;SPCx[XAhX
dLEN	reg	d3
dTMP1	reg	d1
dTMP2	reg	d2
aINTS	reg	a0
aBUF	reg	a1
aSSTS	reg	a2
aDREG	reg	a3
aPSNS	reg	a4
	lea.l	SPC_INTS(aSPC),aINTS
	lea.l	SPC_SSTS(aSPC),aSSTS
	lea.l	SPC_DREG(aSPC),aDREG
	lea.l	SPC_PSNS(aSPC),aPSNS
;0̂Ƃ256ƌȂ
	tst.l	dLEN
	bne	@f
	move.w	#256,dLEN
@@:
;----------------
;REQ=1҂
@@:	move.b	(aINTS),d0
	moveq.l	#SPC_INTS_DC,d1
	and.b	d0,d1
	PATCH_bne	s_dataini_2nd,s_dataini_disconnected
	moveq.l	#SPC_INTS_SR,d1
	and.b	d0,d1
	PATCH_bne	s_dataini_2nd,s_dataini_error
	move.b	(aPSNS),d0
	bpl	@b			;REQ=0
;REQ=1

	PATCH_bra	s_dataini_2nd,s_dataini_2nd

	PATCH_END

;----------------------------------------------------------------
;	ύXO
;		00FFD260 48E77078               movem.l	d1-d3/a1-a4,-(sp)
;			:
;		00FFD37E
;----------------------------------------------------------------

	PATCH_DATA	s_dataini_2nd,$00FFD260,$00FFD37E,$48E77078

s_dataini_2nd:

;----------------
;tF[YmF
;<d0.b:(aPSNS)
	and.b	#SPC_PHASE_MASK,d0
	cmp.b	#SPC_DATAIN_PHASE,d0
	PATCH_bne	s_dataini_2nd,s_dataini_error	;f[^CtF[YɂȂĂȂ
	move.b	d0,SPC_PCTL(aSPC)
;----------------
;Zbg
	move.b	#0,SPC_TEMP(aSPC)
	move.l	dLEN,d0
	swap.w	d0
	move.b	d0,SPC_TCH(aSPC)
	rol.l	#8,d0
	move.b	d0,SPC_TCM(aSPC)
	rol.l	#8,d0
	move.b	d0,SPC_TCL(aSPC)
;----------------
;]Jn
	move.b	(aINTS),(aINTS)		;INTSNA
	move.b	#SPC_SCMD_CC_TR,SPC_SCMD(aSPC)	;]Jn
;----------------
;Jn҂
s_dataini_wait_trip:
	moveq.l	#(SPC_SSTS_INIT|SPC_SSTS_TARG|SPC_SSTS_BUSY|SPC_SSTS_TRIP),d0
	and.b	(aSSTS),d0
	cmp.b	#(SPC_SSTS_INIT|SPC_SSTS_BUSY|SPC_SSTS_TRIP),d0	;(SSTS&(INIT|TARG|BUSY|TRIP))!=(INIT|BUSY|TRIP)
	bne	s_dataini_wait_trip	;CjVG[^œ]łȂBJn҂
	move.l	dLEN,dTMP2		;JEg
	lsr.l	#3,dTMP2		;JEg/8
	beq	s_dataini_cont_frac	;8oCgBp([)
;8oCgȏ
;<dTMP2.l:JEg/8
	moveq.l	#1,d0			;$7001
	.cpu	68030
	and.b	((*)-3,pc,d0.l*2),d0	;0=68000,1=68030
	.cpu	68000
	bne	s_dataini_cont_68030	;680308oCgȏBp(68030)
;680008oCgȏ
  .if 0
	move.w	aBUF,d0
	lsr.w	#1,d0
	bcc	s_dataini_cont_68030	;680008oCgȏŋAhXBp(68030)
;680008oCgȏŊAhX
  .else
;68000LSL.W #8,D0x̂ŋAhX̂ƂMOVE.BŃɏ
  .endif
	bra	s_dataini_cont_68000	;p(68000)

;----------------
;荞݂(68000)
s_dataini_int_68000:
	moveq.l	#.not.SPC_INTS_SR,d0
	and.b	(aINTS),d0		;(INTS&~SR)!=$00
	bne	s_dataini_fin		;SRȊOB]I
;SR̂(68000)
	btst.b	#0,(aSSTS)		;(SSTS&DE)==$00
	beq	s_dataini_noint_68000	;SR݂̂FIFOł͂ȂB荞݂Ȃ(68000)
;SR݂̂FIFO(68000)
	bra	s_dataini_fin		;]I

;[v(68000)
s_dataini_high_68000:
	swap.w	dTMP2
;[v(68000)
s_dataini_loop_68000:
	tst.b	(aINTS)			;INTS!=$00
	bne	s_dataini_int_68000	;荞݂B荞݂(68000)
;荞݂Ȃ(68000)
s_dataini_noint_68000:
	btst.b	#1,(aSSTS)		;(SSTS&DF)==$00
	beq	s_dataini_loop_68000	;FIFOtł͂ȂB[v(68000)
;FIFOt(68000)
    .rept 8
	move.b	(aDREG),(aBUF)+		;DREG(AhX)BAhX+1AhX
    .endm
;p(68000)
s_dataini_cont_68000:
	dbra	dTMP2,s_dataini_loop_68000	;JEg/8=JEg/8-1B[v(68000)
	swap.w	dTMP2
	dbra	dTMP2,s_dataini_high_68000	;JEg/8=JEg/8-65536B[v(68000)
;c肪8oCg
	and.w	#7,dLEN			;JEg%8
;<dLEN.w:JEg(0`7)
	bra	s_dataini_cont_frac	;p([)

;----------------
;荞݂(68030)
s_dataini_int_68030:
	moveq.l	#.not.SPC_INTS_SR,d0
	and.b	(aINTS),d0		;(INTS&~SR)!=$00
	bne	s_dataini_fin		;SRȊOB]I
;SR̂(68030)
	btst.b	#0,(aSSTS)		;(SSTS&DE)==$00
	beq	s_dataini_noint_68030	;SR݂̂FIFOł͂ȂB荞݂Ȃ(68030)
;SR݂̂FIFO(68030)
	bra	s_dataini_fin		;]I

;[v(68030)
s_dataini_loop_68030:
	tst.b	(aINTS)			;INTS!=$00
	bne	s_dataini_int_68030	;荞݂B荞݂(68030)
;荞݂Ȃ(68030)
s_dataini_noint_68030:
	btst.b	#1,(aSSTS)		;(SSTS&DF)==$00
	beq	s_dataini_loop_68030	;FIFOtł͂ȂB[v(68030)
;FIFOt(68030)
  .rept 2
	move.b	(aDREG),d0		;DREGd0
	lsl.w	#8,d0
	move.b	(aDREG),d0		;DREGd0
	swap.w	d0
	move.b	(aDREG),d0		;DREGd0
	lsl.w	#8,d0
	move.b	(aDREG),d0		;DREGd0
	move.l	d0,(aBUF)+		;d0(AhX)BAhX+4AhX
  .endm
;p(68030)
s_dataini_cont_68030:
	subq.l	#8,dLEN			;JEg=JEg-8
	bcc	s_dataini_loop_68030	;[v(68030)
;c肪8oCg
	and.w	#7,dLEN			;JEg%8
;<dLEN.w:JEg(0`7)
	bra	s_dataini_cont_frac	;p([)

;----------------
;荞݂([)
s_dataini_int_frac:
	moveq.l	#.not.SPC_INTS_SR,d0
	and.b	(aINTS),d0		;(INTS&~SR)!=$00
	bne	s_dataini_fin		;SRȊOB]I
;SR̂([)
	btst.b	#0,(aSSTS)		;(SSTS&DE)==$00
	beq	s_dataini_notempty_frac	;SR݂̂FIFOł͂ȂBFIFOł͂Ȃ([)
;SR݂̂FIFO([)
	bra	s_dataini_fin		;]I

;[v([)
s_dataini_loop_frac:
	tst.b	(aINTS)			;INTS!=$00
	bne	s_dataini_int_frac	;荞݂B荞݂([)
;荞݂Ȃ([)
	btst.b	#0,(aSSTS)		;(SSTS&DE)!=$00
	bne	s_dataini_loop_frac	;FIFOB[v([)
;FIFOł͂Ȃ([)
s_dataini_notempty_frac:
	move.b	(aDREG),(aBUF)+		;DREG(AhX)BAhX+1AhX
;p([)
;<dLEN.w:JEg(0`7)
s_dataini_cont_frac:
	dbra	dLEN,s_dataini_loop_frac	;JEg-1JEgB[v([)

;----------------
;]I
s_dataini_fin:
	moveq.l	#0,d0			;$00000000d0
;荞ݑ҂
s_dataini_wait_cc:
	move.b	(aINTS),d0		;INTSd0Bd0==$00
	beq	s_dataini_wait_cc	;荞݂ȂB荞ݑ҂
	move.b	d0,(aINTS)		;d0INTSBINTSNA
	moveq.l	#SPC_INTS_CC,dTMP1
	and.b	d0,dTMP1		;(d0&CC)==$00
	beq	s_dataini_end		;CCȂBA
	moveq.l	#.not.(SPC_INTS_CC|SPC_INTS_SR),dTMP1
	and.b	d0,dTMP1		;(d0&~(CC|SR))!=$00
	bne	s_dataini_end		;CCSRȊOBA
	moveq.l	#0,d0			;$00000000d0
;A
;d0Ԃ
s_dataini_end:
	movem.l	(sp)+,SAVE_REGS
	rts

s_dataini_error:
	moveq.l	#0,d0
	move.b	(aINTS),d0
	move.b	d0,(aINTS)
	swap.w	d0
	move.b	(aPSNS),d0
	bra	s_dataini_end

s_dataini_disconnected:
	SCSI	_S_RESET
	moveq.l	#-1,d0
	bra	s_dataini_end

	PATCH_END



;----------------------------------------------------------------
;
;	OtBbN֌WIOCSR[o[X[hɂȂ܂܂ɂȂ
;	https://stdkmd.net/bugsx68k/#rom_drawmode
;
;----------------------------------------------------------------

;----------------------------------------------------------------
;	ύXO
;		00FFDCEA B07CFFFF               cmp.w	#$FFFF,d0
;		00FFDCEE
;----------------------------------------------------------------

	PATCH_DATA	drawmode,$00FFDCEA,$00FFDCEE,$B07CFFFF

	cmp.w	#-1,d1

	PATCH_END



;----------------------------------------------------------------
;
;	pb`f[^̖
;
;----------------------------------------------------------------

	PATCH_END_END



	.end
